
/*===---- vecintrin.h - Standard header for type generic math ---------------===*\


 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
\*===----------------------------------------------------------------------===*/


#ifndef __VECINTRIN_H
#define __VECINTRIN_H

#if !defined(__VEC__)
#error "Use -fzvector to enable vector extensions"
#endif



#define __ATTRS_o_ai __attribute__((__overloadable__, __always_inline__))

vector signed char __ATTRS_o_ai
vec_abs(vector signed char __a) __asm__("__IBMBuiltin_vec_abs_VScVSc");

vector signed short __ATTRS_o_ai
vec_abs(vector signed short __a) __asm__("__IBMBuiltin_vec_abs_VSsVSs");

vector signed int __ATTRS_o_ai
vec_abs(vector signed int __a) __asm__("__IBMBuiltin_vec_abs_VSiVSi");

vector unsigned int __ATTRS_o_ai
vec_addc(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_addc_VUiVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_andc(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_andc_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_andc(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_andc_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_andc(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_andc_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_andc(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_andc_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_andc(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_andc_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_andc(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_andc_VScVBcVSc");

vector bool char __ATTRS_o_ai
vec_andc(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_andc_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_andc(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_andc_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_andc(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_andc_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_andc(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_andc_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_andc(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_andc_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_andc(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_andc_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_andc(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_andc_VSsVBsVSs");

vector bool short __ATTRS_o_ai
vec_andc(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_andc_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_andc(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_andc_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_andc(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_andc(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_andc_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_andc(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_andc_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_andc(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_andc(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_andc_VSiVBiVSi");

vector bool int __ATTRS_o_ai
vec_andc(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_andc_VBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_avg(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_avg_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_avg(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_avg_VScVScVSc");

vector unsigned short __ATTRS_o_ai
vec_avg(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_avg_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_avg(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_avg_VSsVSsVSs");

vector unsigned int __ATTRS_o_ai
vec_avg(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_avg_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_avg(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_avg_VSiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmpeq(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmpeq_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmpeq(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmpeq_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmpeq(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmpeq_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmpeq(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmpeq_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmpeq(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmpeq_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmpeq(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmpeq_VBiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmpge(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmpge_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmpge(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmpge_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmpge(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmpge_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmpge(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmpge_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmpge(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmpge_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmpge(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmpge_VBiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmpgt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmpgt_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmpgt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmpgt_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmpgt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmpgt_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmpgt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmpgt_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmpgt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmpgt_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmpgt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmpgt_VBiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmple(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmple_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmple(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmple_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmple(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmple_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmple(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmple_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmple(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmple_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmple(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmple_VBiVSiVSi");

vector bool char __ATTRS_o_ai
vec_cmplt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_cmplt_VBcVUcVUc");

vector bool char __ATTRS_o_ai
vec_cmplt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_cmplt_VBcVScVSc");

vector bool short __ATTRS_o_ai
vec_cmplt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_cmplt_VBsVUsVUs");

vector bool short __ATTRS_o_ai
vec_cmplt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_cmplt_VBsVSsVSs");

vector bool int __ATTRS_o_ai
vec_cmplt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_cmplt_VBiVUiVUi");

vector bool int __ATTRS_o_ai
vec_cmplt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_cmplt_VBiVSiVSi");

vector unsigned char __ATTRS_o_ai
vec_max(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_max_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_max(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_max_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_max(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_max_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_max(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_max_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_max(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_max_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_max(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_max_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_max(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_max_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_max(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_max_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_max(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_max_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_max(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_max_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_max(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_max_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_max(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_max_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_max(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_max_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_max(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_max_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_max(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_max_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_max(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_max_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_max(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_max_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_max(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_max_VSiVBiVSi");

vector unsigned char __ATTRS_o_ai
vec_mergeh(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mergeh_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_mergeh(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mergeh_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_mergeh(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_mergeh_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_mergeh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mergeh_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mergeh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mergeh_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_mergeh(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_mergeh_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_mergeh(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mergeh_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_mergeh(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mergeh_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_mergeh(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_mergeh_VBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_mergel(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mergel_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_mergel(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mergel_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_mergel(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_mergel_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_mergel(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mergel_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mergel(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mergel_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_mergel(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_mergel_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_mergel(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mergel_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_mergel(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mergel_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_mergel(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_mergel_VBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_min(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_min_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_min(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_min_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_min(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_min_VUcVBcVUc");

vector signed char __ATTRS_o_ai
vec_min(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_min_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_min(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_min_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_min(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_min_VScVBcVSc");

vector unsigned short __ATTRS_o_ai
vec_min(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_min_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_min(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_min_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_min(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_min_VUsVBsVUs");

vector signed short __ATTRS_o_ai
vec_min(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_min_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_min(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_min_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_min(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_min_VSsVBsVSs");

vector unsigned int __ATTRS_o_ai
vec_min(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_min_VUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_min(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_min_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_min(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_min_VUiVBiVUi");

vector signed int __ATTRS_o_ai
vec_min(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_min_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_min(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_min_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_min(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_min_VSiVBiVSi");

vector unsigned short __ATTRS_o_ai
vec_mladd(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_mladd_VUsVUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mladd(vector unsigned short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_mladd_VSsVUsVSsVSs");

vector signed short __ATTRS_o_ai
vec_mladd(vector signed short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_mladd_VSsVSsVUsVUs");

vector signed short __ATTRS_o_ai
vec_mladd(vector signed short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_mladd_VSsVSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_mule(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mule_VUsVUcVUc");

vector signed short __ATTRS_o_ai
vec_mule(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mule_VSsVScVSc");

vector unsigned int __ATTRS_o_ai
vec_mule(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mule_VUiVUsVUs");

vector signed int __ATTRS_o_ai
vec_mule(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mule_VSiVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_mulo(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mulo_VUsVUcVUc");

vector signed short __ATTRS_o_ai
vec_mulo(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mulo_VSsVScVSc");

vector unsigned int __ATTRS_o_ai
vec_mulo(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mulo_VUiVUsVUs");

vector signed int __ATTRS_o_ai
vec_mulo(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mulo_VSiVSsVSs");

vector unsigned char __ATTRS_o_ai
vec_nor(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_nor_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_nor(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_nor_VScVScVSc");

vector bool char __ATTRS_o_ai
vec_nor(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_nor_VBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_nor(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_nor_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_nor(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_nor_VSsVSsVSs");

vector bool short __ATTRS_o_ai
vec_nor(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_nor_VBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_nor(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_nor_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_nor(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_nor_VSiVSiVSi");

vector bool int __ATTRS_o_ai
vec_nor(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_nor_VBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_pack(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_pack_VUcVUsVUs");

vector signed char __ATTRS_o_ai
vec_pack(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_pack_VScVSsVSs");

vector bool char __ATTRS_o_ai
vec_pack(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_pack_VBcVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_pack(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_pack_VUsVUiVUi");

vector signed short __ATTRS_o_ai
vec_pack(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_pack_VSsVSiVSi");

vector bool short __ATTRS_o_ai
vec_pack(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_pack_VBsVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_packs(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_packs_VUcVUsVUs");

vector signed char __ATTRS_o_ai
vec_packs(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_packs_VScVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_packs(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_packs_VUsVUiVUi");

vector signed short __ATTRS_o_ai
vec_packs(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_packs_VSsVSiVSi");

vector unsigned char __ATTRS_o_ai
vec_packsu(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_packsu_VUcVUsVUs");

vector unsigned char __ATTRS_o_ai
vec_packsu(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_packsu_VUcVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_packsu(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_packsu_VUsVUiVUi");

vector unsigned short __ATTRS_o_ai
vec_packsu(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_packsu_VUsVSiVSi");

vector unsigned char __ATTRS_o_ai
vec_perm(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUcVUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_perm(vector signed char __a, vector signed char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VScVScVScVUc");

vector bool char __ATTRS_o_ai
vec_perm(vector bool char __a, vector bool char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VBcVBcVBcVUc");

vector unsigned short __ATTRS_o_ai
vec_perm(vector unsigned short __a, vector unsigned short __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUsVUsVUsVUc");

vector signed short __ATTRS_o_ai
vec_perm(vector signed short __a, vector signed short __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VSsVSsVSsVUc");

vector bool short __ATTRS_o_ai
vec_perm(vector bool short __a, vector bool short __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VBsVBsVBsVUc");

vector unsigned int __ATTRS_o_ai
vec_perm(vector unsigned int __a, vector unsigned int __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VUiVUiVUiVUc");

vector signed int __ATTRS_o_ai
vec_perm(vector signed int __a, vector signed int __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VSiVSiVSiVUc");

vector bool int __ATTRS_o_ai
vec_perm(vector bool int __a, vector bool int __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_VBiVBiVBiVUc");

vector unsigned char __ATTRS_o_ai
vec_rl(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_rl_VUcVUcVUc");

vector signed char __ATTRS_o_ai
vec_rl(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_rl_VScVScVUc");

vector unsigned short __ATTRS_o_ai
vec_rl(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_rl_VUsVUsVUs");

vector signed short __ATTRS_o_ai
vec_rl(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_rl_VSsVSsVUs");

vector unsigned int __ATTRS_o_ai
vec_rl(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_rl_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_rl(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_rl_VSiVSiVUi");

vector unsigned char __ATTRS_o_ai
vec_sel(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sel_VUcVUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_sel(vector unsigned char __a, vector unsigned char __b, vector bool char __c) __asm__("__IBMBuiltin_vec_sel_VUcVUcVUcVBc");

vector signed char __ATTRS_o_ai
vec_sel(vector signed char __a, vector signed char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sel_VScVScVScVUc");

vector signed char __ATTRS_o_ai
vec_sel(vector signed char __a, vector signed char __b, vector bool char __c) __asm__("__IBMBuiltin_vec_sel_VScVScVScVBc");

vector bool char __ATTRS_o_ai
vec_sel(vector bool char __a, vector bool char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sel_VBcVBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_sel(vector bool char __a, vector bool char __b, vector bool char __c) __asm__("__IBMBuiltin_vec_sel_VBcVBcVBcVBc");

vector unsigned short __ATTRS_o_ai
vec_sel(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_sel_VUsVUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_sel(vector unsigned short __a, vector unsigned short __b, vector bool short __c) __asm__("__IBMBuiltin_vec_sel_VUsVUsVUsVBs");

vector signed short __ATTRS_o_ai
vec_sel(vector signed short __a, vector signed short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_sel_VSsVSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_sel(vector signed short __a, vector signed short __b, vector bool short __c) __asm__("__IBMBuiltin_vec_sel_VSsVSsVSsVBs");

vector bool short __ATTRS_o_ai
vec_sel(vector bool short __a, vector bool short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_sel_VBsVBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_sel(vector bool short __a, vector bool short __b, vector bool short __c) __asm__("__IBMBuiltin_vec_sel_VBsVBsVBsVBs");

vector unsigned int __ATTRS_o_ai
vec_sel(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VUiVUiVUiVUi");

vector unsigned int __ATTRS_o_ai
vec_sel(vector unsigned int __a, vector unsigned int __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VUiVUiVUiVBi");

vector signed int __ATTRS_o_ai
vec_sel(vector signed int __a, vector signed int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VSiVSiVSiVUi");

vector signed int __ATTRS_o_ai
vec_sel(vector signed int __a, vector signed int __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VSiVSiVSiVBi");

vector bool int __ATTRS_o_ai
vec_sel(vector bool int __a, vector bool int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_sel_VBiVBiVBiVUi");

vector bool int __ATTRS_o_ai
vec_sel(vector bool int __a, vector bool int __b, vector bool int __c) __asm__("__IBMBuiltin_vec_sel_VBiVBiVBiVBi");

vector unsigned char __ATTRS_o_ai
vec_sll(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_sll(vector unsigned char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VUcVUcVUs");

vector unsigned char __ATTRS_o_ai
vec_sll(vector unsigned char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VUcVUcVUi");

vector signed char __ATTRS_o_ai
vec_sll(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_sll(vector signed char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VScVScVUs");

vector signed char __ATTRS_o_ai
vec_sll(vector signed char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VScVScVUi");

vector bool char __ATTRS_o_ai
vec_sll(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_sll(vector bool char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VBcVBcVUs");

vector bool char __ATTRS_o_ai
vec_sll(vector bool char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VBcVBcVUi");

vector unsigned short __ATTRS_o_ai
vec_sll(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_sll(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_sll(vector unsigned short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VUsVUsVUi");

vector signed short __ATTRS_o_ai
vec_sll(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_sll(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_sll(vector signed short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VSsVSsVUi");

vector bool short __ATTRS_o_ai
vec_sll(vector bool short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VBsVBsVUc");

vector bool short __ATTRS_o_ai
vec_sll(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_sll(vector bool short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VBsVBsVUi");

vector unsigned int __ATTRS_o_ai
vec_sll(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_sll(vector unsigned int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VUiVUiVUs");

vector unsigned int __ATTRS_o_ai
vec_sll(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_sll(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_sll(vector signed int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VSiVSiVUs");

vector signed int __ATTRS_o_ai
vec_sll(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VSiVSiVUi");

vector bool int __ATTRS_o_ai
vec_sll(vector bool int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_VBiVBiVUc");

vector bool int __ATTRS_o_ai
vec_sll(vector bool int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_VBiVBiVUs");

vector bool int __ATTRS_o_ai
vec_sll(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_VBiVBiVUi");

vector unsigned char __ATTRS_o_ai
vec_srl(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_srl(vector unsigned char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VUcVUcVUs");

vector unsigned char __ATTRS_o_ai
vec_srl(vector unsigned char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VUcVUcVUi");

vector signed char __ATTRS_o_ai
vec_srl(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_srl(vector signed char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VScVScVUs");

vector signed char __ATTRS_o_ai
vec_srl(vector signed char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VScVScVUi");

vector bool char __ATTRS_o_ai
vec_srl(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_srl(vector bool char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VBcVBcVUs");

vector bool char __ATTRS_o_ai
vec_srl(vector bool char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VBcVBcVUi");

vector unsigned short __ATTRS_o_ai
vec_srl(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_srl(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_srl(vector unsigned short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VUsVUsVUi");

vector signed short __ATTRS_o_ai
vec_srl(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_srl(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_srl(vector signed short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VSsVSsVUi");

vector bool short __ATTRS_o_ai
vec_srl(vector bool short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VBsVBsVUc");

vector bool short __ATTRS_o_ai
vec_srl(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_srl(vector bool short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VBsVBsVUi");

vector unsigned int __ATTRS_o_ai
vec_srl(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_srl(vector unsigned int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VUiVUiVUs");

vector unsigned int __ATTRS_o_ai
vec_srl(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VUiVUiVUi");

vector signed int __ATTRS_o_ai
vec_srl(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_srl(vector signed int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VSiVSiVUs");

vector signed int __ATTRS_o_ai
vec_srl(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VSiVSiVUi");

vector bool int __ATTRS_o_ai
vec_srl(vector bool int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_VBiVBiVUc");

vector bool int __ATTRS_o_ai
vec_srl(vector bool int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_VBiVBiVUs");

vector bool int __ATTRS_o_ai
vec_srl(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_VBiVBiVUi");

vector unsigned int __ATTRS_o_ai
vec_subc(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_subc_VUiVUiVUi");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_eq_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_eq_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_eq(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_eq_iVScVSc");

signed int __ATTRS_o_ai
vec_all_eq(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_eq_iVScVBc");

signed int __ATTRS_o_ai
vec_all_eq(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_eq_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_eq(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_eq_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_eq(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_eq_iVBcVBc");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_eq_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_eq_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_eq(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_eq_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_eq(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_eq_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_eq(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_eq_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_eq(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_eq_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_eq(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_eq_iVBsVBs");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_eq_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_eq_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_eq(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_eq_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_eq(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_eq_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_eq(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_eq_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_eq(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_eq_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_eq(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_eq_iVBiVBi");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_ge_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ge_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_ge(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_ge_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_ge(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_ge_iVScVSc");

signed int __ATTRS_o_ai
vec_all_ge(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ge_iVScVBc");

signed int __ATTRS_o_ai
vec_all_ge(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_ge_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_ge_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ge_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_ge(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_ge_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_ge(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_ge_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_ge(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ge_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_ge(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_ge_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_ge_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ge_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_ge(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_ge_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_ge(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_ge_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_ge(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ge_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_ge(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_ge_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_gt_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_gt_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_gt(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_gt_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_gt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_gt_iVScVSc");

signed int __ATTRS_o_ai
vec_all_gt(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_gt_iVScVBc");

signed int __ATTRS_o_ai
vec_all_gt(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_gt_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_gt_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_gt_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_gt(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_gt_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_gt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_gt_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_gt(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_gt_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_gt(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_gt_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_gt_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_gt_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_gt(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_gt_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_gt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_gt_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_gt(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_gt_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_gt(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_gt_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_le_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_le_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_le(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_le_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_le(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_le_iVScVSc");

signed int __ATTRS_o_ai
vec_all_le(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_le_iVScVBc");

signed int __ATTRS_o_ai
vec_all_le(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_le_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_le_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_le_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_le(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_le_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_le(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_le_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_le(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_le_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_le(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_le_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_le_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_le_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_le(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_le_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_le(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_le_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_le(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_le_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_le(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_le_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_lt_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_lt_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_lt(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_lt_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_lt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_lt_iVScVSc");

signed int __ATTRS_o_ai
vec_all_lt(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_lt_iVScVBc");

signed int __ATTRS_o_ai
vec_all_lt(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_lt_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_lt_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_lt_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_lt(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_lt_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_lt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_lt_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_lt(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_lt_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_lt(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_lt_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_lt_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_lt_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_lt(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_lt_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_lt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_lt_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_lt(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_lt_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_lt(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_lt_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_ne_iVUcVUc");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ne_iVUcVBc");

signed int __ATTRS_o_ai
vec_all_ne(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_ne_iVScVSc");

signed int __ATTRS_o_ai
vec_all_ne(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ne_iVScVBc");

signed int __ATTRS_o_ai
vec_all_ne(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_all_ne_iVBcVUc");

signed int __ATTRS_o_ai
vec_all_ne(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_all_ne_iVBcVSc");

signed int __ATTRS_o_ai
vec_all_ne(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ne_iVBcVBc");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_ne_iVUsVUs");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ne_iVUsVBs");

signed int __ATTRS_o_ai
vec_all_ne(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_ne_iVSsVSs");

signed int __ATTRS_o_ai
vec_all_ne(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ne_iVSsVBs");

signed int __ATTRS_o_ai
vec_all_ne(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_all_ne_iVBsVUs");

signed int __ATTRS_o_ai
vec_all_ne(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_all_ne_iVBsVSs");

signed int __ATTRS_o_ai
vec_all_ne(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ne_iVBsVBs");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_ne_iVUiVUi");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ne_iVUiVBi");

signed int __ATTRS_o_ai
vec_all_ne(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_ne_iVSiVSi");

signed int __ATTRS_o_ai
vec_all_ne(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ne_iVSiVBi");

signed int __ATTRS_o_ai
vec_all_ne(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_all_ne_iVBiVUi");

signed int __ATTRS_o_ai
vec_all_ne(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_all_ne_iVBiVSi");

signed int __ATTRS_o_ai
vec_all_ne(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ne_iVBiVBi");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_eq_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_eq_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_eq(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_eq_iVScVSc");

signed int __ATTRS_o_ai
vec_any_eq(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_eq_iVScVBc");

signed int __ATTRS_o_ai
vec_any_eq(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_eq_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_eq(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_eq_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_eq(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_eq_iVBcVBc");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_eq_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_eq_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_eq(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_eq_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_eq(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_eq_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_eq(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_eq_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_eq(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_eq_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_eq(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_eq_iVBsVBs");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_eq_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_eq_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_eq(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_eq_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_eq(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_eq_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_eq(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_eq_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_eq(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_eq_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_eq(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_eq_iVBiVBi");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_ge_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ge_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_ge(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_ge_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_ge(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_ge_iVScVSc");

signed int __ATTRS_o_ai
vec_any_ge(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ge_iVScVBc");

signed int __ATTRS_o_ai
vec_any_ge(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_ge_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_ge_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ge_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_ge(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_ge_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_ge(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_ge_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_ge(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ge_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_ge(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_ge_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_ge_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ge_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_ge(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_ge_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_ge(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_ge_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_ge(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ge_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_ge(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_ge_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_gt_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_gt_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_gt(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_gt_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_gt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_gt_iVScVSc");

signed int __ATTRS_o_ai
vec_any_gt(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_gt_iVScVBc");

signed int __ATTRS_o_ai
vec_any_gt(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_gt_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_gt_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_gt_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_gt(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_gt_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_gt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_gt_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_gt(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_gt_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_gt(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_gt_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_gt_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_gt_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_gt(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_gt_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_gt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_gt_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_gt(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_gt_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_gt(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_gt_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_le_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_le_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_le(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_le_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_le(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_le_iVScVSc");

signed int __ATTRS_o_ai
vec_any_le(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_le_iVScVBc");

signed int __ATTRS_o_ai
vec_any_le(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_le_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_le_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_le_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_le(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_le_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_le(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_le_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_le(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_le_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_le(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_le_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_le_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_le_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_le(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_le_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_le(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_le_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_le(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_le_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_le(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_le_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_lt_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_lt_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_lt(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_lt_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_lt(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_lt_iVScVSc");

signed int __ATTRS_o_ai
vec_any_lt(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_lt_iVScVBc");

signed int __ATTRS_o_ai
vec_any_lt(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_lt_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_lt_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_lt_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_lt(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_lt_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_lt(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_lt_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_lt(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_lt_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_lt(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_lt_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_lt_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_lt_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_lt(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_lt_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_lt(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_lt_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_lt(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_lt_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_lt(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_lt_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_ne_iVUcVUc");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ne_iVUcVBc");

signed int __ATTRS_o_ai
vec_any_ne(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_ne_iVScVSc");

signed int __ATTRS_o_ai
vec_any_ne(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ne_iVScVBc");

signed int __ATTRS_o_ai
vec_any_ne(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_any_ne_iVBcVUc");

signed int __ATTRS_o_ai
vec_any_ne(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_any_ne_iVBcVSc");

signed int __ATTRS_o_ai
vec_any_ne(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_any_ne_iVBcVBc");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_ne_iVUsVUs");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ne_iVUsVBs");

signed int __ATTRS_o_ai
vec_any_ne(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_ne_iVSsVSs");

signed int __ATTRS_o_ai
vec_any_ne(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ne_iVSsVBs");

signed int __ATTRS_o_ai
vec_any_ne(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_any_ne_iVBsVUs");

signed int __ATTRS_o_ai
vec_any_ne(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_any_ne_iVBsVSs");

signed int __ATTRS_o_ai
vec_any_ne(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_any_ne_iVBsVBs");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_ne_iVUiVUi");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ne_iVUiVBi");

signed int __ATTRS_o_ai
vec_any_ne(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_ne_iVSiVSi");

signed int __ATTRS_o_ai
vec_any_ne(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ne_iVSiVBi");

signed int __ATTRS_o_ai
vec_any_ne(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_any_ne_iVBiVUi");

signed int __ATTRS_o_ai
vec_any_ne(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_any_ne_iVBiVSi");

signed int __ATTRS_o_ai
vec_any_ne(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_any_ne_iVBiVBi");

vector double __ATTRS_o_ai
vec_promote(double __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_f8_Vddi");

vector signed long long __ATTRS_o_ai
vec_promote(signed long long __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_s8_VSlli");

vector unsigned long long __ATTRS_o_ai
vec_promote(unsigned long long __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_u8_VUlli");

vector signed int __ATTRS_o_ai
vec_promote(signed int __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_s4_VSiii");

vector unsigned int __ATTRS_o_ai
vec_promote(unsigned int __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_u4_VUiii");

vector signed short __ATTRS_o_ai
vec_promote(signed short __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_s2_VSssi");

vector unsigned short __ATTRS_o_ai
vec_promote(unsigned short __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_u2_VUssi");

vector signed char __ATTRS_o_ai
vec_promote(signed char __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_s1_VScci");

vector unsigned char __ATTRS_o_ai
vec_promote(unsigned char __a, signed int __b) __asm__("__IBMBuiltin_vec_promote_u1_VUcci");

double __ATTRS_o_ai
vec_extract(vector double __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_f8_dVdi");

signed long long __ATTRS_o_ai
vec_extract(vector signed long long __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_s8_lVSli");

unsigned long long __ATTRS_o_ai
vec_extract(vector unsigned long long __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u8_lVUli");

unsigned long long __ATTRS_o_ai
vec_extract(vector bool long long __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u8_lVBli");

signed int __ATTRS_o_ai
vec_extract(vector signed int __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_s4_iVSii");

unsigned int __ATTRS_o_ai
vec_extract(vector unsigned int __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u4_iVUii");

unsigned int __ATTRS_o_ai
vec_extract(vector bool int __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u4_iVBii");

signed short __ATTRS_o_ai
vec_extract(vector signed short __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_s2_sVSsi");

unsigned short __ATTRS_o_ai
vec_extract(vector unsigned short __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u2_sVUsi");

unsigned short __ATTRS_o_ai
vec_extract(vector bool short __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u2_sVBsi");

signed char __ATTRS_o_ai
vec_extract(vector signed char __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_s1_cVSci");

unsigned char __ATTRS_o_ai
vec_extract(vector unsigned char __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u1_cVUci");

unsigned char __ATTRS_o_ai
vec_extract(vector bool char __a, signed int __b) __asm__("__IBMBuiltin_vec_extract_u1_cVBci");

vector double __ATTRS_o_ai
vec_splats(double __a) __asm__("__IBMBuiltin_vec_splats_f8_Vdd");

vector signed long long __ATTRS_o_ai
vec_splats(signed long long __a) __asm__("__IBMBuiltin_vec_splats_s8_VSll");

vector unsigned long long __ATTRS_o_ai
vec_splats(unsigned long long __a) __asm__("__IBMBuiltin_vec_splats_u8_VUll");

vector signed int __ATTRS_o_ai
vec_splats(signed int __a) __asm__("__IBMBuiltin_vec_splats_s4_VSii");

vector unsigned int __ATTRS_o_ai
vec_splats(unsigned int __a) __asm__("__IBMBuiltin_vec_splats_u4_VUii");

vector signed short __ATTRS_o_ai
vec_splats(signed short __a) __asm__("__IBMBuiltin_vec_splats_s2_VSss");

vector unsigned short __ATTRS_o_ai
vec_splats(unsigned short __a) __asm__("__IBMBuiltin_vec_splats_u2_VUss");

vector signed char __ATTRS_o_ai
vec_splats(signed char __a) __asm__("__IBMBuiltin_vec_splats_s1_VScc");

vector unsigned char __ATTRS_o_ai
vec_splats(unsigned char __a) __asm__("__IBMBuiltin_vec_splats_u1_VUcc");

vector double __ATTRS_o_ai
vec_insert(double __a, vector double __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_f8_VddVdi");

vector signed long long __ATTRS_o_ai
vec_insert(signed long long __a, vector signed long long __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_s8_VSllVSli");

vector unsigned long long __ATTRS_o_ai
vec_insert(unsigned long long __a, vector unsigned long long __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u8_VUllVUli");

vector unsigned long long __ATTRS_o_ai
vec_insert(unsigned long long __a, vector bool long long __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u8_VUllVBli");

vector signed int __ATTRS_o_ai
vec_insert(signed int __a, vector signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_s4_VSiiVSii");

vector unsigned int __ATTRS_o_ai
vec_insert(unsigned int __a, vector unsigned int __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u4_VUiiVUii");

vector unsigned int __ATTRS_o_ai
vec_insert(unsigned int __a, vector bool int __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u4_VUiiVBii");

vector signed short __ATTRS_o_ai
vec_insert(signed short __a, vector signed short __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_s2_VSssVSsi");

vector unsigned short __ATTRS_o_ai
vec_insert(unsigned short __a, vector unsigned short __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u2_VUssVUsi");

vector unsigned short __ATTRS_o_ai
vec_insert(unsigned short __a, vector bool short __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u2_VUssVBsi");

vector signed char __ATTRS_o_ai
vec_insert(signed char __a, vector signed char __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_s1_VSccVSci");

vector unsigned char __ATTRS_o_ai
vec_insert(unsigned char __a, vector unsigned char __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u1_VUccVUci");

vector unsigned char __ATTRS_o_ai
vec_insert(unsigned char __a, vector bool char __b, signed int __c) __asm__("__IBMBuiltin_vec_insert_u1_VUccVBci");

vector double __ATTRS_o_ai
vec_abs(vector double __a) __asm__("__IBMBuiltin_vec_abs_8_VdVd");

vector double __ATTRS_o_ai
vec_nabs(vector double __a) __asm__("__IBMBuiltin_vec_nabs_VdVd");

vector double __ATTRS_o_ai
vec_sqrt(vector double __a) __asm__("__IBMBuiltin_vec_sqrt_VdVd");

vector double __ATTRS_o_ai
vec_roundc(vector double __a) __asm__("__IBMBuiltin_vec_roundc_VdVd");

vector bool long long __ATTRS_o_ai
vec_cmpeq(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmpeq(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmpeq(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_cmpeq(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_cmpeq_8_VBlVBlVBl");

vector bool long long __ATTRS_o_ai
vec_cmpge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmpge_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmple(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmple_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmpge(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmpge_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmpge(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmpge_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_cmple(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmple_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmple(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmple_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_cmpgt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmpgt_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmplt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_cmplt_8_VBlVdVd");

vector bool long long __ATTRS_o_ai
vec_cmpgt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmpgt_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmpgt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmpgt_8_VBlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_cmplt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_cmplt_8_VBlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_cmplt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_cmplt_8_VBlVUlVUl");

signed int __ATTRS_o_ai
vec_all_eq(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_eq(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_eq(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_eq(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_eq(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_eq(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_eq(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_eq_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_all_ne(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_ne(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_ne(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_ne(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_ne(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_ne(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_ne(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ne_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_all_gt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_lt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_gt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_gt(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_gt(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_lt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_lt(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_lt(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_gt(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_gt(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_lt(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_lt(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_ge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_le(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_le_8_iVdVd");

signed int __ATTRS_o_ai
vec_all_ge(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_ge(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_ge(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_le(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_all_le(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_all_le(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_ge(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_ge(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_all_le(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_all_le(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_eq(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_eq(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_eq(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_eq(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_eq(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_eq(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_eq(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_eq_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_any_ne(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_ne(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_ne(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_ne(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_ne(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_ne(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_ne(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ne_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_any_gt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_lt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_gt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_gt(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_gt(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_lt(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_lt(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_lt(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_gt(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_gt(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_gt_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_lt(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_lt(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_lt_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_ge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_le(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_le_8_iVdVd");

signed int __ATTRS_o_ai
vec_any_ge(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_ge(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_ge(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_le(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVSlVSl");

signed int __ATTRS_o_ai
vec_any_le(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVSlVBl");

signed int __ATTRS_o_ai
vec_any_le(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVBlVSl");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_ge(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_ge(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_ge_8_iVBlVUl");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVUlVUl");

signed int __ATTRS_o_ai
vec_any_le(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVUlVBl");

signed int __ATTRS_o_ai
vec_any_le(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_any_le_8_iVBlVUl");

vector signed long long __ATTRS_o_ai
vec_ctsl(vector double __a, signed int __b) __asm__("__IBMBuiltin_vec_ctsl_VSlVdi");

vector unsigned long long __ATTRS_o_ai
vec_ctul(vector double __a, signed int __b) __asm__("__IBMBuiltin_vec_ctul_VUlVdi");

vector double __ATTRS_o_ai
vec_ctd(vector signed long long __a, signed int __b) __asm__("__IBMBuiltin_vec_ctd_VdVSli");

vector double __ATTRS_o_ai
vec_ctd(vector unsigned long long __a, signed int __b) __asm__("__IBMBuiltin_vec_ctd_VdVUli");

vector double __ATTRS_o_ai
vec_msub(vector double __a, vector double __b, vector double __c) __asm__("__IBMBuiltin_vec_msub_VdVdVdVd");

vector double __ATTRS_o_ai
vec_andc(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_andc_8_VdVdVd");

vector double __ATTRS_o_ai
vec_andc(vector double __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_andc_8_VdVdVBl");

vector double __ATTRS_o_ai
vec_andc(vector bool long long __a, vector double __b) __asm__("__IBMBuiltin_vec_andc_8_VdVBlVd");

vector unsigned long long __ATTRS_o_ai
vec_andc(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_andc_8_VUlVUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_andc(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_andc_8_VUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_andc(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_andc_8_VUlVBlVUl");

vector bool long long __ATTRS_o_ai
vec_andc(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_andc_8_VBlVBlVBl");

vector signed long long __ATTRS_o_ai
vec_andc(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_andc_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_andc(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_andc_8_VSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_andc(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_andc_8_VSlVBlVSl");

vector double __ATTRS_o_ai
vec_nor(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_nor_8_VdVdVd");

vector unsigned long long __ATTRS_o_ai
vec_nor(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_nor_8_VUlVUlVUl");

vector bool long long __ATTRS_o_ai
vec_nor(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_nor_8_VBlVBlVBl");

vector signed long long __ATTRS_o_ai
vec_nor(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_nor_8_VSlVSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_mergeh(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_mergeh_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_mergeh(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_mergeh_8_VSlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_mergeh(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_mergeh_8_VBlVBlVBl");

vector double __ATTRS_o_ai
vec_mergeh(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_mergeh_8_VdVdVd");

vector unsigned long long __ATTRS_o_ai
vec_mergel(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_mergel_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_mergel(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_mergel_8_VSlVSlVSl");

vector bool long long __ATTRS_o_ai
vec_mergel(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_mergel_8_VBlVBlVBl");

vector double __ATTRS_o_ai
vec_mergel(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_mergel_8_VdVdVd");

vector unsigned long long __ATTRS_o_ai
vec_permi(vector unsigned long long __a, vector unsigned long long __b, signed int __c) __asm__("__IBMBuiltin_vec_permi_VUlVUlVUli");

vector signed long long __ATTRS_o_ai
vec_permi(vector signed long long __a, vector signed long long __b, signed int __c) __asm__("__IBMBuiltin_vec_permi_VSlVSlVSli");

vector bool long long __ATTRS_o_ai
vec_permi(vector bool long long __a, vector bool long long __b, signed int __c) __asm__("__IBMBuiltin_vec_permi_VBlVBlVBli");

vector double __ATTRS_o_ai
vec_permi(vector double __a, vector double __b, signed int __c) __asm__("__IBMBuiltin_vec_permi_VdVdVdi");

vector double __ATTRS_o_ai
vec_sel(vector double __a, vector double __b, vector bool long long __c) __asm__("__IBMBuiltin_vec_sel_8_VdVdVdVBl");

vector double __ATTRS_o_ai
vec_sel(vector double __a, vector double __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_sel_8_VdVdVdVUl");

vector bool long long __ATTRS_o_ai
vec_sel(vector bool long long __a, vector bool long long __b, vector bool long long __c) __asm__("__IBMBuiltin_vec_sel_8_VBlVBlVBlVBl");

vector bool long long __ATTRS_o_ai
vec_sel(vector bool long long __a, vector bool long long __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_sel_8_VBlVBlVBlVUl");

vector unsigned long long __ATTRS_o_ai
vec_sel(vector unsigned long long __a, vector unsigned long long __b, vector bool long long __c) __asm__("__IBMBuiltin_vec_sel_8_VUlVUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_sel(vector unsigned long long __a, vector unsigned long long __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_sel_8_VUlVUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_sel(vector signed long long __a, vector signed long long __b, vector bool long long __c) __asm__("__IBMBuiltin_vec_sel_8_VSlVSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_sel(vector signed long long __a, vector signed long long __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_sel_8_VSlVSlVSlVUl");

vector unsigned char __ATTRS_o_ai
vec_sldw(vector unsigned char __a, vector unsigned char __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VUcVUcVUci");

vector signed char __ATTRS_o_ai
vec_sldw(vector signed char __a, vector signed char __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VScVScVSci");

vector unsigned short __ATTRS_o_ai
vec_sldw(vector unsigned short __a, vector unsigned short __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VUsVUsVUsi");

vector signed short __ATTRS_o_ai
vec_sldw(vector signed short __a, vector signed short __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VSsVSsVSsi");

vector unsigned int __ATTRS_o_ai
vec_sldw(vector unsigned int __a, vector unsigned int __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VUiVUiVUii");

vector signed int __ATTRS_o_ai
vec_sldw(vector signed int __a, vector signed int __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_VSiVSiVSii");

vector signed char __ATTRS_o_ai
vec_xld2(signed long __a, signed char * __b) __asm__("__IBMBuiltin_vec_xld2_VSclcA");

vector unsigned char __ATTRS_o_ai
vec_xld2(signed long __a, unsigned char * __b) __asm__("__IBMBuiltin_vec_xld2_VUclcA");

vector signed short __ATTRS_o_ai
vec_xld2(signed long __a, signed short * __b) __asm__("__IBMBuiltin_vec_xld2_VSslsA");

vector unsigned short __ATTRS_o_ai
vec_xld2(signed long __a, unsigned short * __b) __asm__("__IBMBuiltin_vec_xld2_VUslsA");

vector signed int __ATTRS_o_ai
vec_xld2(signed long __a, signed int * __b) __asm__("__IBMBuiltin_vec_xld2_VSiliA");

vector unsigned int __ATTRS_o_ai
vec_xld2(signed long __a, unsigned int * __b) __asm__("__IBMBuiltin_vec_xld2_VUiliA");

vector signed char __ATTRS_o_ai
vec_xlw4(signed long __a, signed char * __b) __asm__("__IBMBuiltin_vec_xlw4_VSclcA");

vector unsigned char __ATTRS_o_ai
vec_xlw4(signed long __a, unsigned char * __b) __asm__("__IBMBuiltin_vec_xlw4_VUclcA");

vector signed short __ATTRS_o_ai
vec_xlw4(signed long __a, signed short * __b) __asm__("__IBMBuiltin_vec_xlw4_VSslsA");

vector unsigned short __ATTRS_o_ai
vec_xlw4(signed long __a, unsigned short * __b) __asm__("__IBMBuiltin_vec_xlw4_VUslsA");

vector unsigned int __ATTRS_o_ai
vec_xlw4(signed long __a, unsigned int * __b) __asm__("__IBMBuiltin_vec_xlw4_VUiliA");

vector signed int __ATTRS_o_ai
vec_xlw4(signed long __a, signed int * __b) __asm__("__IBMBuiltin_vec_xlw4_VSiliA");

void __ATTRS_o_ai
vec_xstd2(vector signed char __a, signed long __b, signed char * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSclcA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned char __a, signed long __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUclcA");

void __ATTRS_o_ai
vec_xstd2(vector signed short __a, signed long __b, signed short * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSslsA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned short __a, signed long __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUslsA");

void __ATTRS_o_ai
vec_xstd2(vector signed int __a, signed long __b, signed int * __c) __asm__("__IBMBuiltin_vec_xstd2_vVSiliA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned int __a, signed long __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_xstd2_vVUiliA");

void __ATTRS_o_ai
vec_xstw4(vector signed char __a, signed long __b, signed char * __c) __asm__("__IBMBuiltin_vec_xstw4_vVSclcA");

void __ATTRS_o_ai
vec_xstw4(vector unsigned char __a, signed long __b, unsigned char * __c) __asm__("__IBMBuiltin_vec_xstw4_vVUclcA");

void __ATTRS_o_ai
vec_xstw4(vector signed short __a, signed long __b, signed short * __c) __asm__("__IBMBuiltin_vec_xstw4_vVSslsA");

void __ATTRS_o_ai
vec_xstw4(vector unsigned short __a, signed long __b, unsigned short * __c) __asm__("__IBMBuiltin_vec_xstw4_vVUslsA");

void __ATTRS_o_ai
vec_xstw4(vector unsigned int __a, signed long __b, unsigned int * __c) __asm__("__IBMBuiltin_vec_xstw4_vVUiliA");

void __ATTRS_o_ai
vec_xstw4(vector signed int __a, signed long __b, signed int * __c) __asm__("__IBMBuiltin_vec_xstw4_vVSiliA");

vector unsigned int __ATTRS_o_ai
vec_cntlz(vector unsigned int __a) __asm__("__IBMBuiltin_vec_cntlz_VUiVUi");

vector unsigned short __ATTRS_o_ai
vec_cntlz(vector unsigned short __a) __asm__("__IBMBuiltin_vec_cntlz_VUsVUs");

vector unsigned char __ATTRS_o_ai
vec_cntlz(vector unsigned char __a) __asm__("__IBMBuiltin_vec_cntlz_VUcVUc");

vector unsigned int __ATTRS_o_ai
vec_cntlz(vector signed int __a) __asm__("__IBMBuiltin_vec_cntlz_VUiVSi");

vector unsigned short __ATTRS_o_ai
vec_cntlz(vector signed short __a) __asm__("__IBMBuiltin_vec_cntlz_VUsVSs");

vector unsigned char __ATTRS_o_ai
vec_cntlz(vector signed char __a) __asm__("__IBMBuiltin_vec_cntlz_VUcVSc");

vector unsigned int __ATTRS_o_ai
vec_popcnt(vector unsigned int __a) __asm__("__IBMBuiltin_vec_popcnt_VUiVUi");

vector unsigned short __ATTRS_o_ai
vec_popcnt(vector unsigned short __a) __asm__("__IBMBuiltin_vec_popcnt_VUsVUs");

vector unsigned char __ATTRS_o_ai
vec_popcnt(vector unsigned char __a) __asm__("__IBMBuiltin_vec_popcnt_VUcVUc");

vector unsigned int __ATTRS_o_ai
vec_popcnt(vector signed int __a) __asm__("__IBMBuiltin_vec_popcnt_VUiVSi");

vector unsigned short __ATTRS_o_ai
vec_popcnt(vector signed short __a) __asm__("__IBMBuiltin_vec_popcnt_VUsVSs");

vector unsigned char __ATTRS_o_ai
vec_popcnt(vector signed char __a) __asm__("__IBMBuiltin_vec_popcnt_VUcVSc");

vector unsigned int __ATTRS_o_ai
vec_pack(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_pack_8_VUiVUlVUl");

vector signed int __ATTRS_o_ai
vec_pack(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_pack_8_VSiVSlVSl");

vector bool int __ATTRS_o_ai
vec_pack(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_pack_8_VBiVBlVBl");

vector unsigned int __ATTRS_o_ai
vec_packs(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_packs_8_VUiVUlVUl");

vector unsigned int __ATTRS_o_ai
vec_packsu(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_packsu_8_VUiVSlVSl");

vector unsigned int __ATTRS_o_ai
vec_packsu(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_packsu_8_VUiVUlVUl");

vector signed int __ATTRS_o_ai
vec_packs(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_packs_8_VSiVSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_rl(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_rl_8_VUlVUlVUl");

vector signed long long __ATTRS_o_ai
vec_rl(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_rl_8_VSlVSlVUl");

vector unsigned char __attribute__((__always_inline__))
vec_add_u128(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_add_u128_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_adde_u128(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_adde_u128_VUcVUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_addc_u128(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_addc_u128_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_addec_u128(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_addec_u128_VUcVUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_sub_u128(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sub_u128_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_sube_u128(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_sube_u128_VUcVUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_subc_u128(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_subc_u128_VUcVUcVUc");

vector unsigned char __attribute__((__always_inline__))
vec_subec_u128(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_subec_u128_VUcVUcVUcVUc");


// zLinux specific vector builtins
unsigned int
__lcbb(const void *op2, unsigned short boundary) __asm__("__IBMBuiltin___lcbb_CvAUs");

vector signed long long __ATTRS_o_ai
vec_abs(vector signed long long __a) __asm__("__IBMBuiltin_vec_abs_8_VSlVSl");

vector unsigned char __ATTRS_o_ai
vec_addc(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_addc_VUcVUcVUc");

vector unsigned short __ATTRS_o_ai
vec_addc(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_addc_VUsVUsVUs");

vector unsigned long long __ATTRS_o_ai
vec_addc(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_addc_8_VUlVUlVUl");

signed int __ATTRS_o_ai
vec_all_ge(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_ge_iVBcVBc");

signed int __ATTRS_o_ai
vec_all_ge(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_ge_iVBsVBs");

signed int __ATTRS_o_ai
vec_all_ge(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_ge_iVBiVBi");

signed int __ATTRS_o_ai
vec_all_ge(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_ge_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_all_gt(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_gt_iVBcVBc");

signed int __ATTRS_o_ai
vec_all_gt(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_gt_iVBsVBs");

signed int __ATTRS_o_ai
vec_all_gt(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_gt_iVBiVBi");

signed int __ATTRS_o_ai
vec_all_gt(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_gt_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_all_le(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_le_iVBcVBc");

signed int __ATTRS_o_ai
vec_all_le(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_le_iVBsVBs");

signed int __ATTRS_o_ai
vec_all_le(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_le_iVBiVBi");

signed int __ATTRS_o_ai
vec_all_le(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_le_8_iVBlVBl");

signed int __ATTRS_o_ai
vec_all_lt(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_all_lt_iVBcVBc");

signed int __ATTRS_o_ai
vec_all_lt(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_all_lt_iVBsVBs");

signed int __ATTRS_o_ai
vec_all_lt(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_all_lt_iVBiVBi");

signed int __ATTRS_o_ai
vec_all_lt(vector bool long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_all_lt_8_iVBlVBl");

signed int __attribute__((__always_inline__))
vec_all_nan(vector double __a) __asm__("__IBMBuiltin_vec_all_nan_iVd");

signed int __attribute__((__always_inline__))
vec_all_nge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_nge_iVdVd");

signed int __attribute__((__always_inline__))
vec_all_ngt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_ngt_iVdVd");

signed int __attribute__((__always_inline__))
vec_all_nle(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_nle_iVdVd");

signed int __attribute__((__always_inline__))
vec_all_nlt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_all_nlt_iVdVd");

signed int __attribute__((__always_inline__))
vec_all_numeric(vector double __a) __asm__("__IBMBuiltin_vec_all_numeric_iVd");

signed int __attribute__((__always_inline__))
vec_any_nge(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_nge_iVdVd");

signed int __attribute__((__always_inline__))
vec_any_ngt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_ngt_iVdVd");

signed int __attribute__((__always_inline__))
vec_any_nle(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_nle_iVdVd");

signed int __attribute__((__always_inline__))
vec_any_nlt(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_any_nlt_iVdVd");

signed int __attribute__((__always_inline__))
vec_any_nan(vector double __a) __asm__("__IBMBuiltin_vec_any_nan_iVd");

signed int __attribute__((__always_inline__))
vec_any_numeric(vector double __a) __asm__("__IBMBuiltin_vec_any_numeric_iVd");

vector signed long long __ATTRS_o_ai
vec_avg(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_avg_8_VSlVSlVSl");

vector unsigned long long __ATTRS_o_ai
vec_avg(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_avg_8_VUlVUlVUl");

vector double __attribute__((__always_inline__))
vec_ceil(vector double __a) __asm__("__IBMBuiltin_vec_ceil_VdVd");

vector unsigned int __attribute__((__always_inline__))
vec_checksum(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_checksum_VUiVUiVUi");

vector bool char __ATTRS_o_ai
vec_cmpeq(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_cmpeq_VBcVBcVBc");

vector bool short __ATTRS_o_ai
vec_cmpeq(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_cmpeq_VBsVBsVBs");

vector bool int __ATTRS_o_ai
vec_cmpeq(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_cmpeq_VBiVBiVBi");

vector unsigned long long __ATTRS_o_ai
vec_cntlz(vector signed long long __a) __asm__("__IBMBuiltin_vec_cntlz_8_VUlVSl");

vector unsigned long long __ATTRS_o_ai
vec_cntlz(vector unsigned long long __a) __asm__("__IBMBuiltin_vec_cntlz_8_VUlVUl");

vector unsigned char __ATTRS_o_ai
vec_cnttz(vector signed char __a) __asm__("__IBMBuiltin_vec_cnttz_VUcVSc");

vector unsigned char __ATTRS_o_ai
vec_cnttz(vector unsigned char __a) __asm__("__IBMBuiltin_vec_cnttz_VUcVUc");

vector unsigned short __ATTRS_o_ai
vec_cnttz(vector signed short __a) __asm__("__IBMBuiltin_vec_cnttz_VUsVSs");

vector unsigned short __ATTRS_o_ai
vec_cnttz(vector unsigned short __a) __asm__("__IBMBuiltin_vec_cnttz_VUsVUs");

vector unsigned int __ATTRS_o_ai
vec_cnttz(vector signed int __a) __asm__("__IBMBuiltin_vec_cnttz_VUiVSi");

vector unsigned int __ATTRS_o_ai
vec_cnttz(vector unsigned int __a) __asm__("__IBMBuiltin_vec_cnttz_VUiVUi");

vector unsigned long long __ATTRS_o_ai
vec_cnttz(vector signed long long __a) __asm__("__IBMBuiltin_vec_cnttz_8_VUlVSl");

vector unsigned long long __ATTRS_o_ai
vec_cnttz(vector unsigned long long __a) __asm__("__IBMBuiltin_vec_cnttz_8_VUlVUl");

vector signed long long __ATTRS_o_ai
vec_extend_s64(vector signed char __a) __asm__("__IBMBuiltin_vec_extend_s64_VSlVSc");

vector signed long long __ATTRS_o_ai
vec_extend_s64(vector signed short __a) __asm__("__IBMBuiltin_vec_extend_s64_VSlVSs");

vector signed long long __ATTRS_o_ai
vec_extend_s64(vector signed int __a) __asm__("__IBMBuiltin_vec_extend_s64_VSlVSi");

vector signed char __ATTRS_o_ai
vec_find_any_eq_idx(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_faee_VScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_find_any_eq_idx(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_faee_VUcVBcVBc");

vector unsigned char __ATTRS_o_ai
vec_find_any_eq_idx(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_faee_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_find_any_eq_idx(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_faee_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_find_any_eq_idx(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_faee_VUsVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_find_any_eq_idx(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_faee_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_find_any_eq_idx(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_faee_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_find_any_eq_idx(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_faee_VUiVBiVBi");

vector unsigned int __ATTRS_o_ai
vec_find_any_eq_idx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_faee_VUiVUiVUi");

vector signed char __ATTRS_o_ai
vec_find_any_ne_idx(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_faee_inv_VScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_find_any_ne_idx(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_faee_inv_VUcVBcVBc");

vector unsigned char __ATTRS_o_ai
vec_find_any_ne_idx(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_faee_inv_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_find_any_ne_idx(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_faee_inv_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_find_any_ne_idx(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_faee_inv_VUsVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_find_any_ne_idx(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_faee_inv_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_find_any_ne_idx(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_faee_inv_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_find_any_ne_idx(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_faee_inv_VUiVBiVBi");

vector unsigned int __ATTRS_o_ai
vec_find_any_ne_idx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_faee_inv_VUiVUiVUi");

vector signed char __ATTRS_o_ai
vec_find_any_eq_or_0_idx(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_faee_zero_VScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_find_any_eq_or_0_idx(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_faee_zero_VUcVBcVBc");

vector unsigned char __ATTRS_o_ai
vec_find_any_eq_or_0_idx(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_faee_zero_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_find_any_eq_or_0_idx(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_faee_zero_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_find_any_eq_or_0_idx(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_faee_zero_VUsVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_find_any_eq_or_0_idx(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_faee_zero_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_find_any_eq_or_0_idx(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_faee_zero_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_find_any_eq_or_0_idx(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_faee_zero_VUiVBiVBi");

vector unsigned int __ATTRS_o_ai
vec_find_any_eq_or_0_idx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_faee_zero_VUiVUiVUi");

vector signed char __ATTRS_o_ai
vec_find_any_ne_or_0_idx(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_faee_zero_inv_VScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_find_any_ne_or_0_idx(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_faee_zero_inv_VUcVBcVBc");

vector unsigned char __ATTRS_o_ai
vec_find_any_ne_or_0_idx(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_faee_zero_inv_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_find_any_ne_or_0_idx(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_faee_zero_inv_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_find_any_ne_or_0_idx(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_faee_zero_inv_VUsVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_find_any_ne_or_0_idx(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_faee_zero_inv_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_find_any_ne_or_0_idx(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_faee_zero_inv_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_find_any_ne_or_0_idx(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_faee_zero_inv_VUiVBiVBi");

vector unsigned int __ATTRS_o_ai
vec_find_any_ne_or_0_idx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_faee_zero_inv_VUiVUiVUi");

vector bool char __ATTRS_o_ai
vec_find_any_eq(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_faee_v_VBcVScVSc");

vector bool char __ATTRS_o_ai
vec_find_any_eq(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_faee_v_VBcVBcVBc");

vector bool char __ATTRS_o_ai
vec_find_any_eq(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_faee_v_VBcVUcVUc");

vector bool short __ATTRS_o_ai
vec_find_any_eq(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_faee_v_VBsVSsVSs");

vector bool short __ATTRS_o_ai
vec_find_any_eq(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_faee_v_VBsVBsVBs");

vector bool short __ATTRS_o_ai
vec_find_any_eq(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_faee_v_VBsVUsVUs");

vector bool int __ATTRS_o_ai
vec_find_any_eq(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_faee_v_VBiVSiVSi");

vector bool int __ATTRS_o_ai
vec_find_any_eq(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_faee_v_VBiVBiVBi");

vector bool int __ATTRS_o_ai
vec_find_any_eq(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_faee_v_VBiVUiVUi");

vector bool char __ATTRS_o_ai
vec_find_any_ne(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_faee_inv_v_VBcVScVSc");

vector bool char __ATTRS_o_ai
vec_find_any_ne(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_faee_inv_v_VBcVBcVBc");

vector bool char __ATTRS_o_ai
vec_find_any_ne(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_faee_inv_v_VBcVUcVUc");

vector bool short __ATTRS_o_ai
vec_find_any_ne(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_faee_inv_v_VBsVSsVSs");

vector bool short __ATTRS_o_ai
vec_find_any_ne(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_faee_inv_v_VBsVBsVBs");

vector bool short __ATTRS_o_ai
vec_find_any_ne(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_faee_inv_v_VBsVUsVUs");

vector bool int __ATTRS_o_ai
vec_find_any_ne(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_faee_inv_v_VBiVSiVSi");

vector bool int __ATTRS_o_ai
vec_find_any_ne(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_faee_inv_v_VBiVBiVBi");

vector bool int __ATTRS_o_ai
vec_find_any_ne(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_faee_inv_v_VBiVUiVUi");

vector signed char __ATTRS_o_ai
vec_find_any_eq_idx_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_cc_VScVScVSciA");

vector unsigned char __ATTRS_o_ai
vec_find_any_eq_idx_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_cc_VUcVBcVBciA");

vector unsigned char __ATTRS_o_ai
vec_find_any_eq_idx_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_cc_VUcVUcVUciA");

vector signed short __ATTRS_o_ai
vec_find_any_eq_idx_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_cc_VSsVSsVSsiA");

vector unsigned short __ATTRS_o_ai
vec_find_any_eq_idx_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_cc_VUsVBsVBsiA");

vector unsigned short __ATTRS_o_ai
vec_find_any_eq_idx_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_cc_VUsVUsVUsiA");

vector signed int __ATTRS_o_ai
vec_find_any_eq_idx_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_cc_VSiVSiVSiiA");

vector unsigned int __ATTRS_o_ai
vec_find_any_eq_idx_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_cc_VUiVBiVBiiA");

vector unsigned int __ATTRS_o_ai
vec_find_any_eq_idx_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_cc_VUiVUiVUiiA");

vector signed char __ATTRS_o_ai
vec_find_any_ne_idx_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_cc_VScVScVSciA");

vector unsigned char __ATTRS_o_ai
vec_find_any_ne_idx_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_cc_VUcVBcVBciA");

vector unsigned char __ATTRS_o_ai
vec_find_any_ne_idx_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_cc_VUcVUcVUciA");

vector signed short __ATTRS_o_ai
vec_find_any_ne_idx_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_cc_VSsVSsVSsiA");

vector unsigned short __ATTRS_o_ai
vec_find_any_ne_idx_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_cc_VUsVBsVBsiA");

vector unsigned short __ATTRS_o_ai
vec_find_any_ne_idx_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_cc_VUsVUsVUsiA");

vector signed int __ATTRS_o_ai
vec_find_any_ne_idx_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_cc_VSiVSiVSiiA");

vector unsigned int __ATTRS_o_ai
vec_find_any_ne_idx_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_cc_VUiVBiVBiiA");

vector unsigned int __ATTRS_o_ai
vec_find_any_ne_idx_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_cc_VUiVUiVUiiA");

vector signed char __ATTRS_o_ai
vec_find_any_eq_or_0_idx_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_cc_VScVScVSciA");

vector unsigned char __ATTRS_o_ai
vec_find_any_eq_or_0_idx_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_cc_VUcVBcVBciA");

vector unsigned char __ATTRS_o_ai
vec_find_any_eq_or_0_idx_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_cc_VUcVUcVUciA");

vector signed short __ATTRS_o_ai
vec_find_any_eq_or_0_idx_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_cc_VSsVSsVSsiA");

vector unsigned short __ATTRS_o_ai
vec_find_any_eq_or_0_idx_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_cc_VUsVBsVBsiA");

vector unsigned short __ATTRS_o_ai
vec_find_any_eq_or_0_idx_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_cc_VUsVUsVUsiA");

vector signed int __ATTRS_o_ai
vec_find_any_eq_or_0_idx_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_cc_VSiVSiVSiiA");

vector unsigned int __ATTRS_o_ai
vec_find_any_eq_or_0_idx_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_cc_VUiVBiVBiiA");

vector unsigned int __ATTRS_o_ai
vec_find_any_eq_or_0_idx_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_cc_VUiVUiVUiiA");

vector signed char __ATTRS_o_ai
vec_find_any_ne_or_0_idx_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_inv_cc_VScVScVSciA");

vector unsigned char __ATTRS_o_ai
vec_find_any_ne_or_0_idx_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_inv_cc_VUcVBcVBciA");

vector unsigned char __ATTRS_o_ai
vec_find_any_ne_or_0_idx_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_inv_cc_VUcVUcVUciA");

vector signed short __ATTRS_o_ai
vec_find_any_ne_or_0_idx_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_inv_cc_VSsVSsVSsiA");

vector unsigned short __ATTRS_o_ai
vec_find_any_ne_or_0_idx_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_inv_cc_VUsVBsVBsiA");

vector unsigned short __ATTRS_o_ai
vec_find_any_ne_or_0_idx_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_inv_cc_VUsVUsVUsiA");

vector signed int __ATTRS_o_ai
vec_find_any_ne_or_0_idx_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_inv_cc_VSiVSiVSiiA");

vector unsigned int __ATTRS_o_ai
vec_find_any_ne_or_0_idx_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_inv_cc_VUiVBiVBiiA");

vector unsigned int __ATTRS_o_ai
vec_find_any_ne_or_0_idx_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_zero_inv_cc_VUiVUiVUiiA");

vector bool char __ATTRS_o_ai
vec_find_any_eq_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_v_cc_VBcVScVSciA");

vector bool char __ATTRS_o_ai
vec_find_any_eq_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_v_cc_VBcVBcVBciA");

vector bool char __ATTRS_o_ai
vec_find_any_eq_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_v_cc_VBcVUcVUciA");

vector bool short __ATTRS_o_ai
vec_find_any_eq_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_v_cc_VBsVSsVSsiA");

vector bool short __ATTRS_o_ai
vec_find_any_eq_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_v_cc_VBsVBsVBsiA");

vector bool short __ATTRS_o_ai
vec_find_any_eq_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_v_cc_VBsVUsVUsiA");

vector bool int __ATTRS_o_ai
vec_find_any_eq_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_v_cc_VBiVSiVSiiA");

vector bool int __ATTRS_o_ai
vec_find_any_eq_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_v_cc_VBiVBiVBiiA");

vector bool int __ATTRS_o_ai
vec_find_any_eq_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_v_cc_VBiVUiVUiiA");

vector bool char __ATTRS_o_ai
vec_find_any_ne_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_v_cc_VBcVScVSciA");

vector bool char __ATTRS_o_ai
vec_find_any_ne_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_v_cc_VBcVBcVBciA");

vector bool char __ATTRS_o_ai
vec_find_any_ne_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_v_cc_VBcVUcVUciA");

vector bool short __ATTRS_o_ai
vec_find_any_ne_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_v_cc_VBsVSsVSsiA");

vector bool short __ATTRS_o_ai
vec_find_any_ne_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_v_cc_VBsVBsVBsiA");

vector bool short __ATTRS_o_ai
vec_find_any_ne_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_v_cc_VBsVUsVUsiA");

vector bool int __ATTRS_o_ai
vec_find_any_ne_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_v_cc_VBiVSiVSiiA");

vector bool int __ATTRS_o_ai
vec_find_any_ne_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_v_cc_VBiVBiVBiiA");

vector bool int __ATTRS_o_ai
vec_find_any_ne_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_faee_inv_v_cc_VBiVUiVUiiA");

vector signed char __ATTRS_o_ai
vec_cmpeq_idx(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_fee_VScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_cmpeq_idx(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_fee_VUcVBcVBc");

vector unsigned char __ATTRS_o_ai
vec_cmpeq_idx(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_fee_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_cmpeq_idx(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_fee_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_cmpeq_idx(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_fee_VUsVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_cmpeq_idx(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_fee_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_cmpeq_idx(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_fee_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_cmpeq_idx(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_fee_VUiVBiVBi");

vector unsigned int __ATTRS_o_ai
vec_cmpeq_idx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_fee_VUiVUiVUi");

vector signed char __ATTRS_o_ai
vec_cmpeq_or_0_idx(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_fee_zero_VScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_cmpeq_or_0_idx(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_fee_zero_VUcVBcVBc");

vector unsigned char __ATTRS_o_ai
vec_cmpeq_or_0_idx(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_fee_zero_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_cmpeq_or_0_idx(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_fee_zero_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_cmpeq_or_0_idx(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_fee_zero_VUsVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_cmpeq_or_0_idx(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_fee_zero_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_cmpeq_or_0_idx(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_fee_zero_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_cmpeq_or_0_idx(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_fee_zero_VUiVBiVBi");

vector unsigned int __ATTRS_o_ai
vec_cmpeq_or_0_idx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_fee_zero_VUiVUiVUi");

vector signed char __ATTRS_o_ai
vec_cmpeq_idx_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_cc_VScVScVSciA");

vector unsigned char __ATTRS_o_ai
vec_cmpeq_idx_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_cc_VUcVBcVBciA");

vector unsigned char __ATTRS_o_ai
vec_cmpeq_idx_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_cc_VUcVUcVUciA");

vector signed short __ATTRS_o_ai
vec_cmpeq_idx_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_cc_VSsVSsVSsiA");

vector unsigned short __ATTRS_o_ai
vec_cmpeq_idx_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_cc_VUsVBsVBsiA");

vector unsigned short __ATTRS_o_ai
vec_cmpeq_idx_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_cc_VUsVUsVUsiA");

vector signed int __ATTRS_o_ai
vec_cmpeq_idx_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_cc_VSiVSiVSiiA");

vector unsigned int __ATTRS_o_ai
vec_cmpeq_idx_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_cc_VUiVBiVBiiA");

vector unsigned int __ATTRS_o_ai
vec_cmpeq_idx_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_cc_VUiVUiVUiiA");

vector signed char __ATTRS_o_ai
vec_cmpeq_or_0_idx_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_zero_cc_VScVScVSciA");

vector unsigned char __ATTRS_o_ai
vec_cmpeq_or_0_idx_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_zero_cc_VUcVBcVBciA");

vector unsigned char __ATTRS_o_ai
vec_cmpeq_or_0_idx_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_zero_cc_VUcVUcVUciA");

vector signed short __ATTRS_o_ai
vec_cmpeq_or_0_idx_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_zero_cc_VSsVSsVSsiA");

vector unsigned short __ATTRS_o_ai
vec_cmpeq_or_0_idx_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_zero_cc_VUsVBsVBsiA");

vector unsigned short __ATTRS_o_ai
vec_cmpeq_or_0_idx_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_zero_cc_VUsVUsVUsiA");

vector signed int __ATTRS_o_ai
vec_cmpeq_or_0_idx_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_zero_cc_VSiVSiVSiiA");

vector unsigned int __ATTRS_o_ai
vec_cmpeq_or_0_idx_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_zero_cc_VUiVBiVBiiA");

vector unsigned int __ATTRS_o_ai
vec_cmpeq_or_0_idx_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fee_zero_cc_VUiVUiVUiiA");

vector signed char __ATTRS_o_ai
vec_cmpne_idx(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_fene_VScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_cmpne_idx(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_fene_VUcVBcVBc");

vector unsigned char __ATTRS_o_ai
vec_cmpne_idx(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_fene_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_cmpne_idx(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_fene_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_cmpne_idx(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_fene_VUsVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_cmpne_idx(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_fene_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_cmpne_idx(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_fene_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_cmpne_idx(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_fene_VUiVBiVBi");

vector unsigned int __ATTRS_o_ai
vec_cmpne_idx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_fene_VUiVUiVUi");

vector signed char __ATTRS_o_ai
vec_cmpne_or_0_idx(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_fene_zero_VScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_cmpne_or_0_idx(vector bool char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_fene_zero_VUcVBcVBc");

vector unsigned char __ATTRS_o_ai
vec_cmpne_or_0_idx(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_fene_zero_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_cmpne_or_0_idx(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_fene_zero_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_cmpne_or_0_idx(vector bool short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_fene_zero_VUsVBsVBs");

vector unsigned short __ATTRS_o_ai
vec_cmpne_or_0_idx(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_fene_zero_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_cmpne_or_0_idx(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_fene_zero_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_cmpne_or_0_idx(vector bool int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_fene_zero_VUiVBiVBi");

vector unsigned int __ATTRS_o_ai
vec_cmpne_or_0_idx(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_fene_zero_VUiVUiVUi");

vector signed char __ATTRS_o_ai
vec_cmpne_idx_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_cc_VScVScVSciA");

vector unsigned char __ATTRS_o_ai
vec_cmpne_idx_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_cc_VUcVBcVBciA");

vector unsigned char __ATTRS_o_ai
vec_cmpne_idx_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_cc_VUcVUcVUciA");

vector signed short __ATTRS_o_ai
vec_cmpne_idx_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_cc_VSsVSsVSsiA");

vector unsigned short __ATTRS_o_ai
vec_cmpne_idx_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_cc_VUsVBsVBsiA");

vector unsigned short __ATTRS_o_ai
vec_cmpne_idx_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_cc_VUsVUsVUsiA");

vector signed int __ATTRS_o_ai
vec_cmpne_idx_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_cc_VSiVSiVSiiA");

vector unsigned int __ATTRS_o_ai
vec_cmpne_idx_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_cc_VUiVBiVBiiA");

vector unsigned int __ATTRS_o_ai
vec_cmpne_idx_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_cc_VUiVUiVUiiA");

vector signed char __ATTRS_o_ai
vec_cmpne_or_0_idx_cc(vector signed char __a, vector signed char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_zero_cc_VScVScVSciA");

vector unsigned char __ATTRS_o_ai
vec_cmpne_or_0_idx_cc(vector bool char __a, vector bool char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_zero_cc_VUcVBcVBciA");

vector unsigned char __ATTRS_o_ai
vec_cmpne_or_0_idx_cc(vector unsigned char __a, vector unsigned char __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_zero_cc_VUcVUcVUciA");

vector signed short __ATTRS_o_ai
vec_cmpne_or_0_idx_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_zero_cc_VSsVSsVSsiA");

vector unsigned short __ATTRS_o_ai
vec_cmpne_or_0_idx_cc(vector bool short __a, vector bool short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_zero_cc_VUsVBsVBsiA");

vector unsigned short __ATTRS_o_ai
vec_cmpne_or_0_idx_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_zero_cc_VUsVUsVUsiA");

vector signed int __ATTRS_o_ai
vec_cmpne_or_0_idx_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_zero_cc_VSiVSiVSiiA");

vector unsigned int __ATTRS_o_ai
vec_cmpne_or_0_idx_cc(vector bool int __a, vector bool int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_zero_cc_VUiVBiVBiiA");

vector unsigned int __ATTRS_o_ai
vec_cmpne_or_0_idx_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_fene_zero_cc_VUiVUiVUiiA");

vector double __attribute__((__always_inline__))
vec_floor(vector double __a) __asm__("__IBMBuiltin_vec_floor_VdVd");

vector bool long long __attribute__((__always_inline__))
vec_fp_test_data_class(vector double __a, unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_fp_test_data_class_VBlVdsiA");

vector signed int __ATTRS_o_ai
vec_gather_element(vector signed int __a, vector unsigned int __b, const signed int * __c, unsigned char __d) __asm__("__IBMBuiltin_vec_gather_element_s4_VSiVSiVUiiACc");

vector unsigned int __ATTRS_o_ai
vec_gather_element(vector unsigned int __a, vector unsigned int __b, const unsigned int * __c, unsigned char __d) __asm__("__IBMBuiltin_vec_gather_element_u4_VUiVUiVUiiACc");

vector bool int __ATTRS_o_ai
vec_gather_element(vector bool int __a, vector unsigned int __b, const unsigned int * __c, unsigned char __d) __asm__("__IBMBuiltin_vec_gather_element_b4_VBiVBiVUiiACc");

vector double __ATTRS_o_ai
vec_gather_element(vector double __a, vector unsigned long long __b, const double * __c, unsigned char __d) __asm__("__IBMBuiltin_vec_gather_element_f8_VdVdVUldACc");

vector signed long long __ATTRS_o_ai
vec_gather_element(vector signed long long __a, vector unsigned long long __b, const signed long long * __c, unsigned char __d) __asm__("__IBMBuiltin_vec_gather_element_s8_VSlVSlVUllACc");

vector unsigned long long __ATTRS_o_ai
vec_gather_element(vector unsigned long long __a, vector unsigned long long __b, const unsigned long long * __c, unsigned char __d) __asm__("__IBMBuiltin_vec_gather_element_u8_VUlVUlVUllACc");

vector bool long long __ATTRS_o_ai
vec_gather_element(vector bool long long __a, vector unsigned long long __b, const unsigned long long * __c, unsigned char __d) __asm__("__IBMBuiltin_vec_gather_element_b8_VBlVBlVUllACc");

vector unsigned char __attribute__((__always_inline__))
vec_genmask(unsigned short __a) __asm__("__IBMBuiltin_vec_genmask_VUcs");

vector unsigned char __attribute__((__always_inline__))
vec_genmasks_8(unsigned char __a, unsigned char __b) __asm__("__IBMBuiltin_vec_genmasks_8_VUccc");

vector unsigned short __attribute__((__always_inline__))
vec_genmasks_16(unsigned char __a, unsigned char __b) __asm__("__IBMBuiltin_vec_genmasks_16_VUscc");

vector unsigned int __attribute__((__always_inline__))
vec_genmasks_32(unsigned char __a, unsigned char __b) __asm__("__IBMBuiltin_vec_genmasks_32_VUicc");

vector unsigned long long __attribute__((__always_inline__))
vec_genmasks_64(unsigned char __a, unsigned char __b) __asm__("__IBMBuiltin_vec_genmasks_64_VUlcc");

vector unsigned short __ATTRS_o_ai
vec_gfmsum(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_gfmsum_VUsVUcVUc");

vector unsigned int __ATTRS_o_ai
vec_gfmsum(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_gfmsum_VUiVUsVUs");

vector unsigned long long __ATTRS_o_ai
vec_gfmsum(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_gfmsum_8_VUlVUiVUi");

vector unsigned char __attribute__((__always_inline__))
vec_gfmsum_128(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_gfmsum_128_VUcVUlVUl");

vector unsigned short __ATTRS_o_ai
vec_gfmsum_accum(vector unsigned char __a, vector unsigned char __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_gfmsum_accum_VUsVUcVUcVUs");

vector unsigned int __ATTRS_o_ai
vec_gfmsum_accum(vector unsigned short __a, vector unsigned short __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_gfmsum_accum_VUiVUsVUsVUi");

vector unsigned long long __ATTRS_o_ai
vec_gfmsum_accum(vector unsigned int __a, vector unsigned int __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_gfmsum_accum_8_VUlVUiVUiVUl");

vector unsigned char __attribute__((__always_inline__))
vec_gfmsum_accum_128(vector unsigned long long __a, vector unsigned long long __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_gfmsum_accum_128_VUcVUlVUlVUc");

vector signed char __ATTRS_o_ai
vec_insert_and_zero(const signed char * __a) __asm__("__IBMBuiltin_vec_insert_and_zero_s1_VSccAC");

vector unsigned char __ATTRS_o_ai
vec_insert_and_zero(const unsigned char * __a) __asm__("__IBMBuiltin_vec_insert_and_zero_u1_VUccAC");

vector signed short __ATTRS_o_ai
vec_insert_and_zero(const signed short * __a) __asm__("__IBMBuiltin_vec_insert_and_zero_s2_VSssAC");

vector unsigned short __ATTRS_o_ai
vec_insert_and_zero(const unsigned short * __a) __asm__("__IBMBuiltin_vec_insert_and_zero_u2_VUssAC");

vector signed int __ATTRS_o_ai
vec_insert_and_zero(const signed int * __a) __asm__("__IBMBuiltin_vec_insert_and_zero_s4_VSiiAC");

vector unsigned int __ATTRS_o_ai
vec_insert_and_zero(const unsigned int * __a) __asm__("__IBMBuiltin_vec_insert_and_zero_u4_VUiiAC");

vector double __ATTRS_o_ai
vec_insert_and_zero(const double * __a) __asm__("__IBMBuiltin_vec_insert_and_zero_f8_VddAC");

vector signed long long __ATTRS_o_ai
vec_insert_and_zero(const signed long long * __a) __asm__("__IBMBuiltin_vec_insert_and_zero_s8_VSllAC");

vector unsigned long long __ATTRS_o_ai
vec_insert_and_zero(const unsigned long long * __a) __asm__("__IBMBuiltin_vec_insert_and_zero_u8_VUllAC");

vector signed char __ATTRS_o_ai
vec_cp_until_zero(vector signed char __a) __asm__("__IBMBuiltin_vec_isolate_str_VScVSc");

vector bool char __ATTRS_o_ai
vec_cp_until_zero(vector bool char __a) __asm__("__IBMBuiltin_vec_isolate_str_VBcVBc");

vector unsigned char __ATTRS_o_ai
vec_cp_until_zero(vector unsigned char __a) __asm__("__IBMBuiltin_vec_isolate_str_VUcVUc");

vector signed short __ATTRS_o_ai
vec_cp_until_zero(vector signed short __a) __asm__("__IBMBuiltin_vec_isolate_str_VSsVSs");

vector bool short __ATTRS_o_ai
vec_cp_until_zero(vector bool short __a) __asm__("__IBMBuiltin_vec_isolate_str_VBsVBs");

vector unsigned short __ATTRS_o_ai
vec_cp_until_zero(vector unsigned short __a) __asm__("__IBMBuiltin_vec_isolate_str_VUsVUs");

vector signed int __ATTRS_o_ai
vec_cp_until_zero(vector signed int __a) __asm__("__IBMBuiltin_vec_isolate_str_VSiVSi");

vector bool int __ATTRS_o_ai
vec_cp_until_zero(vector bool int __a) __asm__("__IBMBuiltin_vec_isolate_str_VBiVBi");

vector unsigned int __ATTRS_o_ai
vec_cp_until_zero(vector unsigned int __a) __asm__("__IBMBuiltin_vec_isolate_str_VUiVUi");

vector signed char __ATTRS_o_ai
vec_cp_until_zero_cc(vector signed char __a, signed int * __b) __asm__("__IBMBuiltin_vec_isolate_str_cc_VScVSciA");

vector bool char __ATTRS_o_ai
vec_cp_until_zero_cc(vector bool char __a, signed int * __b) __asm__("__IBMBuiltin_vec_isolate_str_cc_VBcVBciA");

vector unsigned char __ATTRS_o_ai
vec_cp_until_zero_cc(vector unsigned char __a, signed int * __b) __asm__("__IBMBuiltin_vec_isolate_str_cc_VUcVUciA");

vector signed short __ATTRS_o_ai
vec_cp_until_zero_cc(vector signed short __a, signed int * __b) __asm__("__IBMBuiltin_vec_isolate_str_cc_VSsVSsiA");

vector bool short __ATTRS_o_ai
vec_cp_until_zero_cc(vector bool short __a, signed int * __b) __asm__("__IBMBuiltin_vec_isolate_str_cc_VBsVBsiA");

vector unsigned short __ATTRS_o_ai
vec_cp_until_zero_cc(vector unsigned short __a, signed int * __b) __asm__("__IBMBuiltin_vec_isolate_str_cc_VUsVUsiA");

vector signed int __ATTRS_o_ai
vec_cp_until_zero_cc(vector signed int __a, signed int * __b) __asm__("__IBMBuiltin_vec_isolate_str_cc_VSiVSiiA");

vector bool int __ATTRS_o_ai
vec_cp_until_zero_cc(vector bool int __a, signed int * __b) __asm__("__IBMBuiltin_vec_isolate_str_cc_VBiVBiiA");

vector unsigned int __ATTRS_o_ai
vec_cp_until_zero_cc(vector unsigned int __a, signed int * __b) __asm__("__IBMBuiltin_vec_isolate_str_cc_VUiVUiiA");

vector signed char __ATTRS_o_ai
vec_load_bndry(const signed char * __a, unsigned short __b) __asm__("__IBMBuiltin_vec_load_bndry_s1_VSccACs");

vector unsigned char __ATTRS_o_ai
vec_load_bndry(const unsigned char * __a, unsigned short __b) __asm__("__IBMBuiltin_vec_load_bndry_u1_VUccACs");

vector signed short __ATTRS_o_ai
vec_load_bndry(const signed short * __a, unsigned short __b) __asm__("__IBMBuiltin_vec_load_bndry_s2_VSssACs");

vector unsigned short __ATTRS_o_ai
vec_load_bndry(const unsigned short * __a, unsigned short __b) __asm__("__IBMBuiltin_vec_load_bndry_u2_VUssACs");

vector signed int __ATTRS_o_ai
vec_load_bndry(const signed int * __a, unsigned short __b) __asm__("__IBMBuiltin_vec_load_bndry_s4_VSiiACs");

vector unsigned int __ATTRS_o_ai
vec_load_bndry(const unsigned int * __a, unsigned short __b) __asm__("__IBMBuiltin_vec_load_bndry_u4_VUiiACs");

vector double __ATTRS_o_ai
vec_load_bndry(const double * __a, unsigned short __b) __asm__("__IBMBuiltin_vec_load_bndry_f8_VddACs");

vector signed long long __ATTRS_o_ai
vec_load_bndry(const signed long long * __a, unsigned short __b) __asm__("__IBMBuiltin_vec_load_bndry_s8_VSllACs");

vector unsigned long long __ATTRS_o_ai
vec_load_bndry(const unsigned long long * __a, unsigned short __b) __asm__("__IBMBuiltin_vec_load_bndry_u8_VUllACs");

vector double __attribute__((__always_inline__))
vec_ld2f(const float * __a) __asm__("__IBMBuiltin_vec_ld2f_VdfAC");

vector signed long long __ATTRS_o_ai
vec_load_pair(signed long long __a, signed long long __b) __asm__("__IBMBuiltin_vec_load_pair_s8_VSlll");

vector unsigned long long __ATTRS_o_ai
vec_load_pair(unsigned long long __a, unsigned long long __b) __asm__("__IBMBuiltin_vec_load_pair_u8_VUlll");

vector signed char __ATTRS_o_ai
vec_load_len(const signed char * __a, unsigned int __b) __asm__("__IBMBuiltin_vec_load_len_s1_VSccACi");

vector unsigned char __ATTRS_o_ai
vec_load_len(const unsigned char * __a, unsigned int __b) __asm__("__IBMBuiltin_vec_load_len_u1_VUccACi");

vector signed short __ATTRS_o_ai
vec_load_len(const signed short * __a, unsigned int __b) __asm__("__IBMBuiltin_vec_load_len_s2_VSssACi");

vector unsigned short __ATTRS_o_ai
vec_load_len(const unsigned short * __a, unsigned int __b) __asm__("__IBMBuiltin_vec_load_len_u2_VUssACi");

vector signed int __ATTRS_o_ai
vec_load_len(const signed int * __a, unsigned int __b) __asm__("__IBMBuiltin_vec_load_len_s4_VSiiACi");

vector unsigned int __ATTRS_o_ai
vec_load_len(const unsigned int * __a, unsigned int __b) __asm__("__IBMBuiltin_vec_load_len_u4_VUiiACi");

vector double __ATTRS_o_ai
vec_load_len(const double * __a, unsigned int __b) __asm__("__IBMBuiltin_vec_load_len_f8_VddACi");

vector signed long long __ATTRS_o_ai
vec_load_len(const signed long long * __a, unsigned int __b) __asm__("__IBMBuiltin_vec_load_len_s8_VSllACi");

vector unsigned long long __ATTRS_o_ai
vec_load_len(const unsigned long long * __a, unsigned int __b) __asm__("__IBMBuiltin_vec_load_len_u8_VUllACi");

vector double __attribute__((__always_inline__))
vec_madd(vector double __a, vector double __b, vector double __c) __asm__("__IBMBuiltin_vec_madd_VdVdVdVd");

vector double __ATTRS_o_ai
vec_max(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_max_VdVdVd");

vector signed long long __ATTRS_o_ai
vec_max(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_max_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_max(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_max_8_VSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_max(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_max_8_VSlVBlVSl");

vector unsigned long long __ATTRS_o_ai
vec_max(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_max_8_VUlVUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_max(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_max_8_VUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_max(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_max_8_VUlVBlVUl");

vector signed short __ATTRS_o_ai
vec_meadd(vector signed char __a, vector signed char __b, vector signed short __c) __asm__("__IBMBuiltin_vec_meadd_VSsVScVScVSs");

vector unsigned short __ATTRS_o_ai
vec_meadd(vector unsigned char __a, vector unsigned char __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_meadd_VUsVUcVUcVUs");

vector signed int __ATTRS_o_ai
vec_meadd(vector signed short __a, vector signed short __b, vector signed int __c) __asm__("__IBMBuiltin_vec_meadd_VSiVSsVSsVSi");

vector unsigned int __ATTRS_o_ai
vec_meadd(vector unsigned short __a, vector unsigned short __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_meadd_VUiVUsVUsVUi");

vector signed long long __ATTRS_o_ai
vec_meadd(vector signed int __a, vector signed int __b, vector signed long long __c) __asm__("__IBMBuiltin_vec_meadd_8_VSlVSiVSiVSl");

vector unsigned long long __ATTRS_o_ai
vec_meadd(vector unsigned int __a, vector unsigned int __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_meadd_8_VUlVUiVUiVUl");

vector double __ATTRS_o_ai
vec_min(vector double __a, vector double __b) __asm__("__IBMBuiltin_vec_min_VdVdVd");

vector signed long long __ATTRS_o_ai
vec_min(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_min_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_min(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_min_8_VSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_min(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_min_8_VSlVBlVSl");

vector unsigned long long __ATTRS_o_ai
vec_min(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_min_8_VUlVUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_min(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_min_8_VUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_min(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_min_8_VUlVBlVUl");

vector signed char __ATTRS_o_ai
vec_mhadd(vector signed char __a, vector signed char __b, vector signed char __c) __asm__("__IBMBuiltin_vec_mhadd_VScVScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_mhadd(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_mhadd_VUcVUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_mhadd(vector signed short __a, vector signed short __b, vector signed short __c) __asm__("__IBMBuiltin_vec_mhadd_VSsVSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_mhadd(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_mhadd_VUsVUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_mhadd(vector signed int __a, vector signed int __b, vector signed int __c) __asm__("__IBMBuiltin_vec_mhadd_VSiVSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_mhadd(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_mhadd_VUiVUiVUiVUi");

vector signed char __ATTRS_o_ai
vec_mladd(vector signed char __a, vector signed char __b, vector signed char __c) __asm__("__IBMBuiltin_vec_mladd_VScVScVScVSc");

vector signed char __ATTRS_o_ai
vec_mladd(vector signed char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_mladd_VScVScVUcVUc");

vector signed char __ATTRS_o_ai
vec_mladd(vector unsigned char __a, vector signed char __b, vector signed char __c) __asm__("__IBMBuiltin_vec_mladd_VScVUcVScVSc");

vector unsigned char __ATTRS_o_ai
vec_mladd(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_mladd_VUcVUcVUcVUc");

vector signed int __ATTRS_o_ai
vec_mladd(vector signed int __a, vector signed int __b, vector signed int __c) __asm__("__IBMBuiltin_vec_mladd_VSiVSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_mladd(vector signed int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_mladd_VSiVSiVUiVUi");

vector signed int __ATTRS_o_ai
vec_mladd(vector unsigned int __a, vector signed int __b, vector signed int __c) __asm__("__IBMBuiltin_vec_mladd_VSiVUiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_mladd(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_mladd_VUiVUiVUiVUi");

vector signed short __ATTRS_o_ai
vec_moadd(vector signed char __a, vector signed char __b, vector signed short __c) __asm__("__IBMBuiltin_vec_moadd_VSsVScVScVSs");

vector unsigned short __ATTRS_o_ai
vec_moadd(vector unsigned char __a, vector unsigned char __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_moadd_VUsVUcVUcVUs");

vector signed int __ATTRS_o_ai
vec_moadd(vector signed short __a, vector signed short __b, vector signed int __c) __asm__("__IBMBuiltin_vec_moadd_VSiVSsVSsVSi");

vector unsigned int __ATTRS_o_ai
vec_moadd(vector unsigned short __a, vector unsigned short __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_moadd_VUiVUsVUsVUi");

vector signed long long __ATTRS_o_ai
vec_moadd(vector signed int __a, vector signed int __b, vector signed long long __c) __asm__("__IBMBuiltin_vec_moadd_8_VSlVSiVSiVSl");

vector unsigned long long __ATTRS_o_ai
vec_moadd(vector unsigned int __a, vector unsigned int __b, vector unsigned long long __c) __asm__("__IBMBuiltin_vec_moadd_8_VUlVUiVUiVUl");

vector signed long long __ATTRS_o_ai
vec_mule(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mule_8_VSlVSiVSi");

vector unsigned long long __ATTRS_o_ai
vec_mule(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mule_8_VUlVUiVUi");

vector signed char __ATTRS_o_ai
vec_mulh(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_mulh_VScVScVSc");

vector unsigned char __ATTRS_o_ai
vec_mulh(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_mulh_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_mulh(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_mulh_VSsVSsVSs");

vector unsigned short __ATTRS_o_ai
vec_mulh(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_mulh_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_mulh(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mulh_VSiVSiVSi");

vector unsigned int __ATTRS_o_ai
vec_mulh(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mulh_VUiVUiVUi");

vector signed long long __ATTRS_o_ai
vec_mulo(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_mulo_8_VSlVSiVSi");

vector unsigned long long __ATTRS_o_ai
vec_mulo(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_mulo_8_VUlVUiVUi");

vector signed char __ATTRS_o_ai
vec_nor(vector signed char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_nor_VScVScVBc");

vector signed char __ATTRS_o_ai
vec_nor(vector bool char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_nor_VScVBcVSc");

vector unsigned char __ATTRS_o_ai
vec_nor(vector unsigned char __a, vector bool char __b) __asm__("__IBMBuiltin_vec_nor_VUcVUcVBc");

vector unsigned char __ATTRS_o_ai
vec_nor(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_nor_VUcVBcVUc");

vector signed short __ATTRS_o_ai
vec_nor(vector signed short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_nor_VSsVSsVBs");

vector signed short __ATTRS_o_ai
vec_nor(vector bool short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_nor_VSsVBsVSs");

vector unsigned short __ATTRS_o_ai
vec_nor(vector unsigned short __a, vector bool short __b) __asm__("__IBMBuiltin_vec_nor_VUsVUsVBs");

vector unsigned short __ATTRS_o_ai
vec_nor(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_nor_VUsVBsVUs");

vector signed int __ATTRS_o_ai
vec_nor(vector signed int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_nor_VSiVSiVBi");

vector signed int __ATTRS_o_ai
vec_nor(vector bool int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_nor_VSiVBiVSi");

vector unsigned int __ATTRS_o_ai
vec_nor(vector unsigned int __a, vector bool int __b) __asm__("__IBMBuiltin_vec_nor_VUiVUiVBi");

vector unsigned int __ATTRS_o_ai
vec_nor(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_nor_VUiVBiVUi");

vector double __ATTRS_o_ai
vec_nor(vector double __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_nor_8_VdVdVBl");

vector double __ATTRS_o_ai
vec_nor(vector bool long long __a, vector double __b) __asm__("__IBMBuiltin_vec_nor_8_VdVBlVd");

vector signed long long __ATTRS_o_ai
vec_nor(vector signed long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_nor_8_VSlVSlVBl");

vector signed long long __ATTRS_o_ai
vec_nor(vector bool long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_nor_8_VSlVBlVSl");

vector unsigned long long __ATTRS_o_ai
vec_nor(vector unsigned long long __a, vector bool long long __b) __asm__("__IBMBuiltin_vec_nor_8_VUlVUlVBl");

vector unsigned long long __ATTRS_o_ai
vec_nor(vector bool long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_nor_8_VUlVBlVUl");

vector signed char __ATTRS_o_ai
vec_packs_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_packs_cc_VScVSsVSsiA");

vector unsigned char __ATTRS_o_ai
vec_packs_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_packs_cc_VUcVUsVUsiA");

vector signed short __ATTRS_o_ai
vec_packs_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_packs_cc_VSsVSiVSiiA");

vector unsigned short __ATTRS_o_ai
vec_packs_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_packs_cc_VUsVUiVUiiA");

vector signed int __ATTRS_o_ai
vec_packs_cc(vector signed long long __a, vector signed long long __b, signed int * __c) __asm__("__IBMBuiltin_vec_packs_cc_8_VSiVSlVSliA");

vector unsigned int __ATTRS_o_ai
vec_packs_cc(vector unsigned long long __a, vector unsigned long long __b, signed int * __c) __asm__("__IBMBuiltin_vec_packs_cc_8_VUiVUlVUliA");

vector unsigned char __ATTRS_o_ai
vec_packsu_cc(vector signed short __a, vector signed short __b, signed int * __c) __asm__("__IBMBuiltin_vec_packsu_cc_VUcVSsVSsiA");

vector unsigned char __ATTRS_o_ai
vec_packsu_cc(vector unsigned short __a, vector unsigned short __b, signed int * __c) __asm__("__IBMBuiltin_vec_packsu_cc_VUcVUsVUsiA");

vector unsigned short __ATTRS_o_ai
vec_packsu_cc(vector signed int __a, vector signed int __b, signed int * __c) __asm__("__IBMBuiltin_vec_packsu_cc_VUsVSiVSiiA");

vector unsigned short __ATTRS_o_ai
vec_packsu_cc(vector unsigned int __a, vector unsigned int __b, signed int * __c) __asm__("__IBMBuiltin_vec_packsu_cc_VUsVUiVUiiA");

vector unsigned int __ATTRS_o_ai
vec_packsu_cc(vector signed long long __a, vector signed long long __b, signed int * __c) __asm__("__IBMBuiltin_vec_packsu_cc_8_VUiVSlVSliA");

vector unsigned int __ATTRS_o_ai
vec_packsu_cc(vector unsigned long long __a, vector unsigned long long __b, signed int * __c) __asm__("__IBMBuiltin_vec_packsu_cc_8_VUiVUlVUliA");

vector double __ATTRS_o_ai
vec_perm(vector double __a, vector double __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_8_VdVdVdVUc");

vector signed long long __ATTRS_o_ai
vec_perm(vector signed long long __a, vector signed long long __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_8_VSlVSlVSlVUc");

vector unsigned long long __ATTRS_o_ai
vec_perm(vector unsigned long long __a, vector unsigned long long __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_8_VUlVUlVUlVUc");

vector bool long long __ATTRS_o_ai
vec_perm(vector bool long long __a, vector bool long long __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_perm_8_VBlVBlVBlVUc");

vector unsigned long long __ATTRS_o_ai
vec_popcnt(vector signed long long __a) __asm__("__IBMBuiltin_vec_popcnt_8_VUlVSl");

vector unsigned long long __ATTRS_o_ai
vec_popcnt(vector unsigned long long __a) __asm__("__IBMBuiltin_vec_popcnt_8_VUlVUl");

vector signed char __ATTRS_o_ai
vec_rl_mask(vector signed char __a, vector unsigned char __b, unsigned char __c) __asm__("__IBMBuiltin_vec_rl_mask_VScVScVUcc");

vector unsigned char __ATTRS_o_ai
vec_rl_mask(vector unsigned char __a, vector unsigned char __b, unsigned char __c) __asm__("__IBMBuiltin_vec_rl_mask_VUcVUcVUcc");

vector signed short __ATTRS_o_ai
vec_rl_mask(vector signed short __a, vector unsigned short __b, unsigned char __c) __asm__("__IBMBuiltin_vec_rl_mask_VSsVSsVUsc");

vector unsigned short __ATTRS_o_ai
vec_rl_mask(vector unsigned short __a, vector unsigned short __b, unsigned char __c) __asm__("__IBMBuiltin_vec_rl_mask_VUsVUsVUsc");

vector signed int __ATTRS_o_ai
vec_rl_mask(vector signed int __a, vector unsigned int __b, unsigned char __c) __asm__("__IBMBuiltin_vec_rl_mask_VSiVSiVUic");

vector unsigned int __ATTRS_o_ai
vec_rl_mask(vector unsigned int __a, vector unsigned int __b, unsigned char __c) __asm__("__IBMBuiltin_vec_rl_mask_VUiVUiVUic");

vector signed long long __ATTRS_o_ai
vec_rl_mask(vector signed long long __a, vector unsigned long long __b, unsigned char __c) __asm__("__IBMBuiltin_vec_rl_mask_8_VSlVSlVUlc");

vector unsigned long long __ATTRS_o_ai
vec_rl_mask(vector unsigned long long __a, vector unsigned long long __b, unsigned char __c) __asm__("__IBMBuiltin_vec_rl_mask_8_VUlVUlVUlc");

vector signed char __ATTRS_o_ai
vec_rli(vector signed char __a, unsigned long __b) __asm__("__IBMBuiltin_vec_rli_VScVScl");

vector unsigned char __ATTRS_o_ai
vec_rli(vector unsigned char __a, unsigned long __b) __asm__("__IBMBuiltin_vec_rli_VUcVUcl");

vector signed short __ATTRS_o_ai
vec_rli(vector signed short __a, unsigned long __b) __asm__("__IBMBuiltin_vec_rli_VSsVSsl");

vector unsigned short __ATTRS_o_ai
vec_rli(vector unsigned short __a, unsigned long __b) __asm__("__IBMBuiltin_vec_rli_VUsVUsl");

vector signed int __ATTRS_o_ai
vec_rli(vector signed int __a, unsigned long __b) __asm__("__IBMBuiltin_vec_rli_VSiVSil");

vector unsigned int __ATTRS_o_ai
vec_rli(vector unsigned int __a, unsigned long __b) __asm__("__IBMBuiltin_vec_rli_VUiVUil");

vector signed long long __ATTRS_o_ai
vec_rli(vector signed long long __a, unsigned long __b) __asm__("__IBMBuiltin_vec_rli_8_VSlVSll");

vector unsigned long long __ATTRS_o_ai
vec_rli(vector unsigned long long __a, unsigned long __b) __asm__("__IBMBuiltin_vec_rli_8_VUlVUll");

vector double __attribute__((__always_inline__))
vec_round(vector double __a) __asm__("__IBMBuiltin_vec_round_VdVd");

vector double __attribute__((__always_inline__))
vec_roundm(vector double __a) __asm__("__IBMBuiltin_vec_roundm_VdVd");

vector double __attribute__((__always_inline__))
vec_roundp(vector double __a) __asm__("__IBMBuiltin_vec_roundp_VdVd");

vector double __attribute__((__always_inline__))
vec_roundz(vector double __a) __asm__("__IBMBuiltin_vec_roundz_VdVd");

void __ATTRS_o_ai
vec_scatter_element(vector signed int __a, vector unsigned int __b, signed int * __c, unsigned long long __d) __asm__("__IBMBuiltin_vec_scatter_element_s4_vVSiVUiiAl");

void __ATTRS_o_ai
vec_scatter_element(vector unsigned int __a, vector unsigned int __b, unsigned int * __c, unsigned long long __d) __asm__("__IBMBuiltin_vec_scatter_element_u4_vVUiVUiiAl");

void __ATTRS_o_ai
vec_scatter_element(vector bool int __a, vector unsigned int __b, unsigned int * __c, unsigned long long __d) __asm__("__IBMBuiltin_vec_scatter_element_b4_vVBiVUiiAl");

void __ATTRS_o_ai
vec_scatter_element(vector signed long long __a, vector unsigned long long __b, signed long long * __c, unsigned long long __d) __asm__("__IBMBuiltin_vec_scatter_element_s8_vVSlVUllAl");

void __ATTRS_o_ai
vec_scatter_element(vector unsigned long long __a, vector unsigned long long __b, unsigned long long * __c, unsigned long long __d) __asm__("__IBMBuiltin_vec_scatter_element_u8_vVUlVUllAl");

void __ATTRS_o_ai
vec_scatter_element(vector bool long long __a, vector unsigned long long __b, unsigned long long * __c, unsigned long long __d) __asm__("__IBMBuiltin_vec_scatter_element_b8_vVBlVUllAl");

void __ATTRS_o_ai
vec_scatter_element(vector double __a, vector unsigned long long __b, double * __c, unsigned long long __d) __asm__("__IBMBuiltin_vec_scatter_element_f8_vVdVUldAl");

vector signed char __ATTRS_o_ai
vec_sld(vector signed char __a, vector signed char __b, unsigned long long __c) __asm__("__IBMBuiltin_vec_sld_VScVScVScl");

vector unsigned char __ATTRS_o_ai
vec_sld(vector unsigned char __a, vector unsigned char __b, unsigned long long __c) __asm__("__IBMBuiltin_vec_sld_VUcVUcVUcl");

vector signed short __ATTRS_o_ai
vec_sld(vector signed short __a, vector signed short __b, unsigned long long __c) __asm__("__IBMBuiltin_vec_sld_VSsVSsVSsl");

vector unsigned short __ATTRS_o_ai
vec_sld(vector unsigned short __a, vector unsigned short __b, unsigned long long __c) __asm__("__IBMBuiltin_vec_sld_VUsVUsVUsl");

vector signed int __ATTRS_o_ai
vec_sld(vector signed int __a, vector signed int __b, unsigned long long __c) __asm__("__IBMBuiltin_vec_sld_VSiVSiVSil");

vector unsigned int __ATTRS_o_ai
vec_sld(vector unsigned int __a, vector unsigned int __b, unsigned long long __c) __asm__("__IBMBuiltin_vec_sld_VUiVUiVUil");

vector double __ATTRS_o_ai
vec_sld(vector double __a, vector double __b, unsigned long long __c) __asm__("__IBMBuiltin_vec_sld_8_VdVdVdl");

vector signed long long __ATTRS_o_ai
vec_sld(vector signed long long __a, vector signed long long __b, unsigned long long __c) __asm__("__IBMBuiltin_vec_sld_8_VSlVSlVSll");

vector unsigned long long __ATTRS_o_ai
vec_sld(vector unsigned long long __a, vector unsigned long long __b, unsigned long long __c) __asm__("__IBMBuiltin_vec_sld_8_VUlVUlVUll");

vector signed long long __ATTRS_o_ai
vec_sll(vector signed long long __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_8_VSlVSlVUc");

vector signed long long __ATTRS_o_ai
vec_sll(vector signed long long __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_8_VSlVSlVUs");

vector signed long long __ATTRS_o_ai
vec_sll(vector signed long long __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_8_VSlVSlVUi");

vector unsigned long long __ATTRS_o_ai
vec_sll(vector unsigned long long __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_8_VUlVUlVUc");

vector unsigned long long __ATTRS_o_ai
vec_sll(vector unsigned long long __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_8_VUlVUlVUs");

vector unsigned long long __ATTRS_o_ai
vec_sll(vector unsigned long long __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_8_VUlVUlVUi");

vector bool long long __ATTRS_o_ai
vec_sll(vector bool long long __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sll_8_VBlVBlVUc");

vector bool long long __ATTRS_o_ai
vec_sll(vector bool long long __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sll_8_VBlVBlVUs");

vector bool long long __ATTRS_o_ai
vec_sll(vector bool long long __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sll_8_VBlVBlVUi");

vector signed char __ATTRS_o_ai
vec_slb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slb_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_slb(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slb_VScVScVUc");

vector unsigned char __ATTRS_o_ai
vec_slb(vector unsigned char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_slb_VUcVUcVSc");

vector unsigned char __ATTRS_o_ai
vec_slb(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_slb_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_slb(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_slb_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_slb(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_slb_VSsVSsVUs");

vector unsigned short __ATTRS_o_ai
vec_slb(vector unsigned short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_slb_VUsVUsVSs");

vector unsigned short __ATTRS_o_ai
vec_slb(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_slb_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_slb(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_slb_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_slb(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_slb_VSiVSiVUi");

vector unsigned int __ATTRS_o_ai
vec_slb(vector unsigned int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_slb_VUiVUiVSi");

vector unsigned int __ATTRS_o_ai
vec_slb(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_slb_VUiVUiVUi");

vector double __ATTRS_o_ai
vec_slb(vector double __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_slb_8_VdVdVSl");

vector double __ATTRS_o_ai
vec_slb(vector double __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_slb_8_VdVdVUl");

vector signed long long __ATTRS_o_ai
vec_slb(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_slb_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_slb(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_slb_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_slb(vector unsigned long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_slb_8_VUlVUlVSl");

vector unsigned long long __ATTRS_o_ai
vec_slb(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_slb_8_VUlVUlVUl");

vector double __ATTRS_o_ai
vec_sldw(vector double __a, vector double __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_8_VdVdVdi");

vector signed long long __ATTRS_o_ai
vec_sldw(vector signed long long __a, vector signed long long __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_8_VSlVSlVSli");

vector unsigned long long __ATTRS_o_ai
vec_sldw(vector unsigned long long __a, vector unsigned long long __b, signed int __c) __asm__("__IBMBuiltin_vec_sldw_8_VUlVUlVUli");

vector signed char __ATTRS_o_ai
vec_splat(vector signed char __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__s1_VScVScc");

vector unsigned char __ATTRS_o_ai
vec_splat(vector unsigned char __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__u1_VUcVUcc");

vector bool char __ATTRS_o_ai
vec_splat(vector bool char __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__s1_VBcVBcc");

vector signed short __ATTRS_o_ai
vec_splat(vector signed short __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__s2_VSsVSsc");

vector unsigned short __ATTRS_o_ai
vec_splat(vector unsigned short __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__u2_VUsVUsc");

vector bool short __ATTRS_o_ai
vec_splat(vector bool short __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__s2_VBsVBsc");

vector signed int __ATTRS_o_ai
vec_splat(vector signed int __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__s4_VSiVSic");

vector unsigned int __ATTRS_o_ai
vec_splat(vector unsigned int __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__u4_VUiVUic");

vector bool int __ATTRS_o_ai
vec_splat(vector bool int __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__s4_VBiVBic");

vector double __ATTRS_o_ai
vec_splat(vector double __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__f8_VdVdc");

vector signed long long __ATTRS_o_ai
vec_splat(vector signed long long __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__s8_VSlVSlc");

vector unsigned long long __ATTRS_o_ai
vec_splat(vector unsigned long long __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__u8_VUlVUlc");

vector bool long long __ATTRS_o_ai
vec_splat(vector bool long long __a, unsigned char __b) __asm__("__IBMBuiltin_vec_splat__s8_VBlVBlc");

vector signed char __attribute__((__always_inline__))
vec_splat_s8(signed long long __a) __asm__("__IBMBuiltin_vec_splat_s8__VScl");

vector signed short __attribute__((__always_inline__))
vec_splat_s16(signed short __a) __asm__("__IBMBuiltin_vec_splat_s16__VSss");

vector signed int __attribute__((__always_inline__))
vec_splat_s32(signed short __a) __asm__("__IBMBuiltin_vec_splat_s32__VSis");

vector signed long long __attribute__((__always_inline__))
vec_splat_s64(signed short __a) __asm__("__IBMBuiltin_vec_splat_s64__VSls");

vector unsigned char __attribute__((__always_inline__))
vec_splat_u8(unsigned char __a) __asm__("__IBMBuiltin_vec_splat_u8__VUcc");

vector unsigned short __attribute__((__always_inline__))
vec_splat_u16(unsigned short __a) __asm__("__IBMBuiltin_vec_splat_u16__VUss");

vector unsigned int __attribute__((__always_inline__))
vec_splat_u32(signed short __a) __asm__("__IBMBuiltin_vec_splat_u32__VUis");

vector unsigned long long __attribute__((__always_inline__))
vec_splat_u64(signed short __a) __asm__("__IBMBuiltin_vec_splat_u64__VUls");

vector signed char __ATTRS_o_ai
vec_srab(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_srab_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_srab(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srab_VScVScVUc");

vector unsigned char __ATTRS_o_ai
vec_srab(vector unsigned char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_srab_VUcVUcVSc");

vector unsigned char __ATTRS_o_ai
vec_srab(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srab_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_srab(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_srab_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_srab(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srab_VSsVSsVUs");

vector unsigned short __ATTRS_o_ai
vec_srab(vector unsigned short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_srab_VUsVUsVSs");

vector unsigned short __ATTRS_o_ai
vec_srab(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srab_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_srab(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_srab_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_srab(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srab_VSiVSiVUi");

vector unsigned int __ATTRS_o_ai
vec_srab(vector unsigned int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_srab_VUiVUiVSi");

vector unsigned int __ATTRS_o_ai
vec_srab(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srab_VUiVUiVUi");

vector double __ATTRS_o_ai
vec_srab(vector double __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_srab_8_VdVdVSl");

vector double __ATTRS_o_ai
vec_srab(vector double __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_srab_8_VdVdVUl");

vector signed long long __ATTRS_o_ai
vec_srab(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_srab_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_srab(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_srab_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_srab(vector unsigned long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_srab_8_VUlVUlVSl");

vector unsigned long long __ATTRS_o_ai
vec_srab(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_srab_8_VUlVUlVUl");

vector signed char __ATTRS_o_ai
vec_sral(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_VScVScVUc");

vector signed char __ATTRS_o_ai
vec_sral(vector signed char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_VScVScVUs");

vector signed char __ATTRS_o_ai
vec_sral(vector signed char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_VScVScVUi");

vector unsigned char __ATTRS_o_ai
vec_sral(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_VUcVUcVUc");

vector unsigned char __ATTRS_o_ai
vec_sral(vector unsigned char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_VUcVUcVUs");

vector unsigned char __ATTRS_o_ai
vec_sral(vector unsigned char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_VUcVUcVUi");

vector bool char __ATTRS_o_ai
vec_sral(vector bool char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_VBcVBcVUc");

vector bool char __ATTRS_o_ai
vec_sral(vector bool char __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_VBcVBcVUs");

vector bool char __ATTRS_o_ai
vec_sral(vector bool char __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_VBcVBcVUi");

vector signed short __ATTRS_o_ai
vec_sral(vector signed short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_VSsVSsVUc");

vector signed short __ATTRS_o_ai
vec_sral(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_VSsVSsVUs");

vector signed short __ATTRS_o_ai
vec_sral(vector signed short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_VSsVSsVUi");

vector unsigned short __ATTRS_o_ai
vec_sral(vector unsigned short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_VUsVUsVUc");

vector unsigned short __ATTRS_o_ai
vec_sral(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_VUsVUsVUs");

vector unsigned short __ATTRS_o_ai
vec_sral(vector unsigned short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_VUsVUsVUi");

vector bool short __ATTRS_o_ai
vec_sral(vector bool short __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_VBsVBsVUc");

vector bool short __ATTRS_o_ai
vec_sral(vector bool short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_VBsVBsVUs");

vector bool short __ATTRS_o_ai
vec_sral(vector bool short __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_VBsVBsVUi");

vector signed int __ATTRS_o_ai
vec_sral(vector signed int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_VSiVSiVUc");

vector signed int __ATTRS_o_ai
vec_sral(vector signed int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_VSiVSiVUs");

vector signed int __ATTRS_o_ai
vec_sral(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_VSiVSiVUi");

vector unsigned int __ATTRS_o_ai
vec_sral(vector unsigned int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_VUiVUiVUc");

vector unsigned int __ATTRS_o_ai
vec_sral(vector unsigned int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_VUiVUiVUs");

vector unsigned int __ATTRS_o_ai
vec_sral(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_VUiVUiVUi");

vector bool int __ATTRS_o_ai
vec_sral(vector bool int __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_VBiVBiVUc");

vector bool int __ATTRS_o_ai
vec_sral(vector bool int __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_VBiVBiVUs");

vector bool int __ATTRS_o_ai
vec_sral(vector bool int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_VBiVBiVUi");

vector signed long long __ATTRS_o_ai
vec_sral(vector signed long long __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_8_VSlVSlVUc");

vector signed long long __ATTRS_o_ai
vec_sral(vector signed long long __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_8_VSlVSlVUs");

vector signed long long __ATTRS_o_ai
vec_sral(vector signed long long __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_8_VSlVSlVUi");

vector unsigned long long __ATTRS_o_ai
vec_sral(vector unsigned long long __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_8_VUlVUlVUc");

vector unsigned long long __ATTRS_o_ai
vec_sral(vector unsigned long long __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_8_VUlVUlVUs");

vector unsigned long long __ATTRS_o_ai
vec_sral(vector unsigned long long __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_8_VUlVUlVUi");

vector bool long long __ATTRS_o_ai
vec_sral(vector bool long long __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sral_8_VBlVBlVUc");

vector bool long long __ATTRS_o_ai
vec_sral(vector bool long long __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sral_8_VBlVBlVUs");

vector bool long long __ATTRS_o_ai
vec_sral(vector bool long long __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sral_8_VBlVBlVUi");

vector signed long long __ATTRS_o_ai
vec_srl(vector signed long long __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_8_VSlVSlVUc");

vector signed long long __ATTRS_o_ai
vec_srl(vector signed long long __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_8_VSlVSlVUs");

vector signed long long __ATTRS_o_ai
vec_srl(vector signed long long __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_8_VSlVSlVUi");

vector unsigned long long __ATTRS_o_ai
vec_srl(vector unsigned long long __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_8_VUlVUlVUc");

vector unsigned long long __ATTRS_o_ai
vec_srl(vector unsigned long long __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_8_VUlVUlVUs");

vector unsigned long long __ATTRS_o_ai
vec_srl(vector unsigned long long __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_8_VUlVUlVUi");

vector bool long long __ATTRS_o_ai
vec_srl(vector bool long long __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srl_8_VBlVBlVUc");

vector bool long long __ATTRS_o_ai
vec_srl(vector bool long long __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srl_8_VBlVBlVUs");

vector bool long long __ATTRS_o_ai
vec_srl(vector bool long long __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srl_8_VBlVBlVUi");

vector signed char __ATTRS_o_ai
vec_srb(vector signed char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_srb_VScVScVSc");

vector signed char __ATTRS_o_ai
vec_srb(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srb_VScVScVUc");

vector unsigned char __ATTRS_o_ai
vec_srb(vector unsigned char __a, vector signed char __b) __asm__("__IBMBuiltin_vec_srb_VUcVUcVSc");

vector unsigned char __ATTRS_o_ai
vec_srb(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_srb_VUcVUcVUc");

vector signed short __ATTRS_o_ai
vec_srb(vector signed short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_srb_VSsVSsVSs");

vector signed short __ATTRS_o_ai
vec_srb(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srb_VSsVSsVUs");

vector unsigned short __ATTRS_o_ai
vec_srb(vector unsigned short __a, vector signed short __b) __asm__("__IBMBuiltin_vec_srb_VUsVUsVSs");

vector unsigned short __ATTRS_o_ai
vec_srb(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_srb_VUsVUsVUs");

vector signed int __ATTRS_o_ai
vec_srb(vector signed int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_srb_VSiVSiVSi");

vector signed int __ATTRS_o_ai
vec_srb(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srb_VSiVSiVUi");

vector unsigned int __ATTRS_o_ai
vec_srb(vector unsigned int __a, vector signed int __b) __asm__("__IBMBuiltin_vec_srb_VUiVUiVSi");

vector unsigned int __ATTRS_o_ai
vec_srb(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_srb_VUiVUiVUi");

vector double __ATTRS_o_ai
vec_srb(vector double __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_srb_8_VdVdVSl");

vector double __ATTRS_o_ai
vec_srb(vector double __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_srb_8_VdVdVUl");

vector signed long long __ATTRS_o_ai
vec_srb(vector signed long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_srb_8_VSlVSlVSl");

vector signed long long __ATTRS_o_ai
vec_srb(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_srb_8_VSlVSlVUl");

vector unsigned long long __ATTRS_o_ai
vec_srb(vector unsigned long long __a, vector signed long long __b) __asm__("__IBMBuiltin_vec_srb_8_VUlVUlVSl");

vector unsigned long long __ATTRS_o_ai
vec_srb(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_srb_8_VUlVUlVUl");

void __attribute__((__always_inline__))
vec_st2f(vector double __a, float * __b) __asm__("__IBMBuiltin_vec_st2f_vVdfA");

void __ATTRS_o_ai
vec_store_len(vector signed char __a, signed char * __b, unsigned int __c) __asm__("__IBMBuiltin_vec_store_len_vVSccAi");

void __ATTRS_o_ai
vec_store_len(vector unsigned char __a, unsigned char * __b, unsigned int __c) __asm__("__IBMBuiltin_vec_store_len_vVUccAi");

void __ATTRS_o_ai
vec_store_len(vector signed short __a, signed short * __b, unsigned int __c) __asm__("__IBMBuiltin_vec_store_len_vVSssAi");

void __ATTRS_o_ai
vec_store_len(vector unsigned short __a, unsigned short * __b, unsigned int __c) __asm__("__IBMBuiltin_vec_store_len_vVUssAi");

void __ATTRS_o_ai
vec_store_len(vector signed int __a, signed int * __b, unsigned int __c) __asm__("__IBMBuiltin_vec_store_len_vVSiiAi");

void __ATTRS_o_ai
vec_store_len(vector unsigned int __a, unsigned int * __b, unsigned int __c) __asm__("__IBMBuiltin_vec_store_len_vVUiiAi");

void __ATTRS_o_ai
vec_store_len(vector double __a, double * __b, unsigned int __c) __asm__("__IBMBuiltin_vec_store_len_8_vVddAi");

void __ATTRS_o_ai
vec_store_len(vector signed long long __a, signed long long * __b, unsigned int __c) __asm__("__IBMBuiltin_vec_store_len_8_vVSllAi");

void __ATTRS_o_ai
vec_store_len(vector unsigned long long __a, unsigned long long * __b, unsigned int __c) __asm__("__IBMBuiltin_vec_store_len_8_vVUllAi");

vector unsigned char __ATTRS_o_ai
vec_cmprg_idx(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_strc_VUcVUcVUcVUc");

vector unsigned short __ATTRS_o_ai
vec_cmprg_idx(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_strc_VUsVUsVUsVUs");

vector unsigned int __ATTRS_o_ai
vec_cmprg_idx(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_strc_VUiVUiVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_cmpnrg_idx(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_strc_inv_VUcVUcVUcVUc");

vector unsigned short __ATTRS_o_ai
vec_cmpnrg_idx(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_strc_inv_VUsVUsVUsVUs");

vector unsigned int __ATTRS_o_ai
vec_cmpnrg_idx(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_strc_inv_VUiVUiVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_cmprg_or_0_idx(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_strc_zero_VUcVUcVUcVUc");

vector unsigned short __ATTRS_o_ai
vec_cmprg_or_0_idx(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_strc_zero_VUsVUsVUsVUs");

vector unsigned int __ATTRS_o_ai
vec_cmprg_or_0_idx(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_strc_zero_VUiVUiVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_cmpnrg_or_0_idx(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_strc_inv_zero_VUcVUcVUcVUc");

vector unsigned short __ATTRS_o_ai
vec_cmpnrg_or_0_idx(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_strc_inv_zero_VUsVUsVUsVUs");

vector unsigned int __ATTRS_o_ai
vec_cmpnrg_or_0_idx(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_strc_inv_zero_VUiVUiVUiVUi");

vector bool char __ATTRS_o_ai
vec_cmprg(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_strc_v_VBcVUcVUcVUc");

vector bool short __ATTRS_o_ai
vec_cmprg(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_strc_v_VBsVUsVUsVUs");

vector bool int __ATTRS_o_ai
vec_cmprg(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_strc_v_VBiVUiVUiVUi");

vector bool char __ATTRS_o_ai
vec_cmpnrg(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c) __asm__("__IBMBuiltin_vec_strc_inv_v_VBcVUcVUcVUc");

vector bool short __ATTRS_o_ai
vec_cmpnrg(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c) __asm__("__IBMBuiltin_vec_strc_inv_v_VBsVUsVUsVUs");

vector bool int __ATTRS_o_ai
vec_cmpnrg(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c) __asm__("__IBMBuiltin_vec_strc_inv_v_VBiVUiVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_cmprg_idx_cc(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_cc_VUcVUcVUcVUciA");

vector unsigned short __ATTRS_o_ai
vec_cmprg_idx_cc(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_cc_VUsVUsVUsVUsiA");

vector unsigned int __ATTRS_o_ai
vec_cmprg_idx_cc(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_cc_VUiVUiVUiVUiiA");

vector unsigned char __ATTRS_o_ai
vec_cmpnrg_idx_cc(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_inv_cc_VUcVUcVUcVUciA");

vector unsigned short __ATTRS_o_ai
vec_cmpnrg_idx_cc(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_inv_cc_VUsVUsVUsVUsiA");

vector unsigned int __ATTRS_o_ai
vec_cmpnrg_idx_cc(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_inv_cc_VUiVUiVUiVUiiA");

vector unsigned char __ATTRS_o_ai
vec_cmprg_or_0_idx_cc(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_zero_cc_VUcVUcVUcVUciA");

vector unsigned short __ATTRS_o_ai
vec_cmprg_or_0_idx_cc(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_zero_cc_VUsVUsVUsVUsiA");

vector unsigned int __ATTRS_o_ai
vec_cmprg_or_0_idx_cc(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_zero_cc_VUiVUiVUiVUiiA");

vector unsigned char __ATTRS_o_ai
vec_cmpnrg_or_0_idx_cc(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_inv_zero_cc_VUcVUcVUcVUciA");

vector unsigned short __ATTRS_o_ai
vec_cmpnrg_or_0_idx_cc(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_inv_zero_cc_VUsVUsVUsVUsiA");

vector unsigned int __ATTRS_o_ai
vec_cmpnrg_or_0_idx_cc(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_inv_zero_cc_VUiVUiVUiVUiiA");

vector bool char __ATTRS_o_ai
vec_cmprg_cc(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_v_cc_VBcVUcVUcVUciA");

vector bool short __ATTRS_o_ai
vec_cmprg_cc(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_v_cc_VBsVUsVUsVUsiA");

vector bool int __ATTRS_o_ai
vec_cmprg_cc(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_v_cc_VBiVUiVUiVUiiA");

vector bool char __ATTRS_o_ai
vec_cmpnrg_cc(vector unsigned char __a, vector unsigned char __b, vector unsigned char __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_inv_v_cc_VBcVUcVUcVUciA");

vector bool short __ATTRS_o_ai
vec_cmpnrg_cc(vector unsigned short __a, vector unsigned short __b, vector unsigned short __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_inv_v_cc_VBsVUsVUsVUsiA");

vector bool int __ATTRS_o_ai
vec_cmpnrg_cc(vector unsigned int __a, vector unsigned int __b, vector unsigned int __c, signed int * __d) __asm__("__IBMBuiltin_vec_strc_inv_v_cc_VBiVUiVUiVUiiA");

vector unsigned char __ATTRS_o_ai
vec_subc(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_subc_VUcVUcVUc");

vector unsigned short __ATTRS_o_ai
vec_subc(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_subc_VUsVUsVUs");

vector unsigned long long __ATTRS_o_ai
vec_subc(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_subc_8_VUlVUlVUl");

vector unsigned long long __ATTRS_o_ai
vec_sum2(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sum2_VUlVUsVUs");

vector unsigned long long __ATTRS_o_ai
vec_sum2(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sum2_VUlVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_sum_u128(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_sum_u128_VUcVUiVUi");

vector unsigned char __ATTRS_o_ai
vec_sum_u128(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_sum_u128_8_VUcVUlVUl");

vector unsigned int __ATTRS_o_ai
vec_sum4(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_sum4_VUiVUcVUc");

vector unsigned int __ATTRS_o_ai
vec_sum4(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_sum4_VUiVUsVUs");

signed int __ATTRS_o_ai
vec_test_mask(vector signed char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_test_mask_iVScVUc");

signed int __ATTRS_o_ai
vec_test_mask(vector unsigned char __a, vector unsigned char __b) __asm__("__IBMBuiltin_vec_test_mask_iVUcVUc");

signed int __ATTRS_o_ai
vec_test_mask(vector signed short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_test_mask_iVSsVUs");

signed int __ATTRS_o_ai
vec_test_mask(vector unsigned short __a, vector unsigned short __b) __asm__("__IBMBuiltin_vec_test_mask_iVUsVUs");

signed int __ATTRS_o_ai
vec_test_mask(vector signed int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_test_mask_iVSiVUi");

signed int __ATTRS_o_ai
vec_test_mask(vector unsigned int __a, vector unsigned int __b) __asm__("__IBMBuiltin_vec_test_mask_iVUiVUi");

signed int __ATTRS_o_ai
vec_test_mask(vector double __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_test_mask_8_iVdVUl");

signed int __ATTRS_o_ai
vec_test_mask(vector signed long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_test_mask_8_iVSlVUl");

signed int __ATTRS_o_ai
vec_test_mask(vector unsigned long long __a, vector unsigned long long __b) __asm__("__IBMBuiltin_vec_test_mask_8_iVUlVUl");

vector double __attribute__((__always_inline__))
vec_trunc(vector double __a) __asm__("__IBMBuiltin_vec_trunc_VdVd");

vector signed short __ATTRS_o_ai
vec_unpackh(vector signed char __a) __asm__("__IBMBuiltin_vec_unpackh_s2_VSsVSc");

vector unsigned short __ATTRS_o_ai
vec_unpackh(vector unsigned char __a) __asm__("__IBMBuiltin_vec_unpackh_u2_VUsVUc");

vector bool short __ATTRS_o_ai
vec_unpackh(vector bool char __a) __asm__("__IBMBuiltin_vec_unpackh_s2_VBsVBc");

vector signed int __ATTRS_o_ai
vec_unpackh(vector signed short __a) __asm__("__IBMBuiltin_vec_unpackh_s4_VSiVSs");

vector unsigned int __ATTRS_o_ai
vec_unpackh(vector unsigned short __a) __asm__("__IBMBuiltin_vec_unpackh_u4_VUiVUs");

vector bool int __ATTRS_o_ai
vec_unpackh(vector bool short __a) __asm__("__IBMBuiltin_vec_unpackh_s4_VBiVBs");

vector signed long long __ATTRS_o_ai
vec_unpackh(vector signed int __a) __asm__("__IBMBuiltin_vec_unpackh_s8_VSlVSi");

vector unsigned long long __ATTRS_o_ai
vec_unpackh(vector unsigned int __a) __asm__("__IBMBuiltin_vec_unpackh_u8_VUlVUi");

vector bool long long __ATTRS_o_ai
vec_unpackh(vector bool int __a) __asm__("__IBMBuiltin_vec_unpackh_s8_VBlVBi");

vector signed short __ATTRS_o_ai
vec_unpackl(vector signed char __a) __asm__("__IBMBuiltin_vec_unpackl_s2_VSsVSc");

vector unsigned short __ATTRS_o_ai
vec_unpackl(vector unsigned char __a) __asm__("__IBMBuiltin_vec_unpackl_u2_VUsVUc");

vector bool short __ATTRS_o_ai
vec_unpackl(vector bool char __a) __asm__("__IBMBuiltin_vec_unpackl_s2_VBsVBc");

vector signed int __ATTRS_o_ai
vec_unpackl(vector signed short __a) __asm__("__IBMBuiltin_vec_unpackl_s4_VSiVSs");

vector unsigned int __ATTRS_o_ai
vec_unpackl(vector unsigned short __a) __asm__("__IBMBuiltin_vec_unpackl_u4_VUiVUs");

vector bool int __ATTRS_o_ai
vec_unpackl(vector bool short __a) __asm__("__IBMBuiltin_vec_unpackl_s4_VBiVBs");

vector signed long long __ATTRS_o_ai
vec_unpackl(vector signed int __a) __asm__("__IBMBuiltin_vec_unpackl_s8_VSlVSi");

vector unsigned long long __ATTRS_o_ai
vec_unpackl(vector unsigned int __a) __asm__("__IBMBuiltin_vec_unpackl_u8_VUlVUi");

vector bool long long __ATTRS_o_ai
vec_unpackl(vector bool int __a) __asm__("__IBMBuiltin_vec_unpackl_s8_VBlVBi");

vector double __ATTRS_o_ai
vec_xld2(signed long __a, double * __b) __asm__("__IBMBuiltin_vec_xld2_8_VdldA");

vector signed long long __ATTRS_o_ai
vec_xld2(signed long __a, signed long long * __b) __asm__("__IBMBuiltin_vec_xld2_8_VSlllA");

vector unsigned long long __ATTRS_o_ai
vec_xld2(signed long __a, unsigned long long * __b) __asm__("__IBMBuiltin_vec_xld2_8_VUlllA");

void __ATTRS_o_ai
vec_xstd2(vector double __a, signed long __b, double * __c) __asm__("__IBMBuiltin_vec_xstd2_8_vVdldA");

void __ATTRS_o_ai
vec_xstd2(vector signed long long __a, signed long __b, signed long long * __c) __asm__("__IBMBuiltin_vec_xstd2_8_vVSlllA");

void __ATTRS_o_ai
vec_xstd2(vector unsigned long long __a, signed long __b, unsigned long long * __c) __asm__("__IBMBuiltin_vec_xstd2_8_vVUlllA");





#undef __ATTRS_o_ai

#endif
